////////////////////////////////////////////////////////////////////////////////////
//
//			http://www.interestprograms.ru - ,     
//
/////////////////////////////////////////////////////////////////////////////////////

// ChildView.cpp : implementation of the CChildView class
//

#include "stdafx.h"
#include "CubeRubika3.h"
#include "ChildView.h"
#include ".\childview.h"
#include "MainFrm.h"
#include "PreSettingDlg.h"
#include "NameDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

//   -   
//    .
//#define SHOWHELP



// CChildView
CChildView::CChildView()
: m_pD3D(NULL)
, m_pd3dDevice(NULL)
, m_FullScreen(FALSE)
, m_IsActive(false)
, m_IsRequestPlayerName(TRUE)
{
	

	InitD3D();
}

CChildView::~CChildView()
{
	DataToRegistry();

	RELEASE(m_pd3dDevice);
	RELEASE(m_pD3D);
}


BEGIN_MESSAGE_MAP(CChildView, CWnd)
	ON_WM_PAINT()
	ON_WM_CREATE()
	ON_WM_SIZE()
	ON_WM_LBUTTONDOWN()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONUP()
	ON_WM_KEYDOWN()
END_MESSAGE_MAP()



// CChildView message handlers

BOOL CChildView::PreCreateWindow(CREATESTRUCT& cs) 
{
	if (!CWnd::PreCreateWindow(cs))
		return FALSE;

	cs.style &= ~WS_BORDER;
	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS, 
		//     ,       -
		::LoadCursor(NULL, IDC_ARROW), NULL /*reinterpret_cast<HBRUSH>(COLOR_WINDOW+1)*/, NULL);

	return TRUE;
	
}


int CChildView::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;


	if(CreateDevice3D() != S_OK)
	{
		CString caption;
		AfxGetMainWnd()->GetWindowText(caption);
		caption += " -  Direct3D!";
		AfxGetMainWnd()->SetWindowText(caption);
	}
	

	m_ShowDataPlayers.Init3DFont(m_pd3dDevice);
	m_ControlButtons.InitControlButtons(m_pd3dDevice);

	m_Background.InitVertex(m_pd3dDevice);
	m_CubeRube.InitXFile(m_pd3dDevice, this);
	 
	m_DIMouse.InitDIMouse(this);


	m_DIMouse.m_AngleY = -0.8f;
	m_DIMouse.m_AngleX = -0.8f;

	
	DataFromRegistry();

	if(m_IsRequestPlayerName == TRUE)
	{
		SetPlayerName();
	}

	

	return 0;
}


void CChildView::OnPaint() 
{
	//      (   ,
	//    .)   
	//  ,     

	if(m_IsActive == false)
		CPaintDC dc(this); // device context for painting
	
	//     OnPaint
	//    OnIdle 
	//   OnPaint      
	//     -  
	// ..        
	if(Render() != S_OK)
	{
		//  
		CWnd::OnPaint();
	}
	
	//      OnPaint, 
	//   ,     WM_PAINT
	//CWnd::OnPaint();
}

void CChildView::SetPlayerName(void)
{
	CNameDlg dlg;
	dlg.m_PlayerName = m_ShowDataPlayers.m_Player.GetPlayerName();
	if(dlg.DoModal() == IDOK)
	{
		m_ShowDataPlayers.m_Player.SetPlayerName(dlg.m_PlayerName);
	}
}

//   Direct3D
HRESULT CChildView::InitD3D(void)
{

	HRESULT hr = S_OK;

	//  D3D_SDK_VERSION -    
	// DirectX  Direct3D
	m_pD3D = Direct3DCreate9(D3D_SDK_VERSION);
	
	if(m_pD3D ==  NULL)
	{
		#ifdef SHOWHELP
			AfxMessageBox(" - Direct3D  !");
		#endif

		return E_FAIL;
	}

	return hr;

}


void CChildView::OnSize(UINT nType, int cx, int cy)
{
	CWnd::OnSize(nType, cx, cy);

	ResetScene();
	
}


//   - 
//          3D ,
//     (   3D )   ,
//      3D    
HRESULT CChildView::SetupMatrices()
{
	HRESULT hr = S_OK;

    //    
    D3DXVECTOR3 vEyePt( 0.0f, 0.0f, -100.0f);

	//     ,
	//    .
    D3DXVECTOR3 vLookatObject( 0.0f, 0.0f, 0.0f );

	//    
    D3DXVECTOR3 vUpCamera( 0.0f, 1.0f, 0.0f );

    D3DXMatrixLookAtLH( &m_matView, &vEyePt, &vLookatObject, &vUpCamera );
    hr = m_pd3dDevice->SetTransform( D3DTS_VIEW, &m_matView );

	if(hr != S_OK) return hr;


	// C   
	//    ,
	
	CRect rc;
	GetClientRect(&rc);
	FLOAT aspect = (float)rc.Width() / rc.Height();
    D3DXMatrixPerspectiveFovLH( &m_matProj, 
								D3DX_PI/4,	// 
								aspect,		//   (    )
								1.0f,		//     
								1000.0f );	//     
    hr = m_pd3dDevice->SetTransform( D3DTS_PROJECTION, &m_matProj );

	return hr;
}



//        
//   
//    Direct3D 
//  /    ResetDevice3D
//    (    , 
//         .) 
HRESULT CChildView::CreateDevice3D(void)
{
	HRESULT hr = S_OK;

	
	//    Direct3D ,
	//     .
	D3DPRESENT_PARAMETERS d3dpp;
	D3DDEVTYPE devtype;
	DWORD vertexproccesing;
	hr = GetBestParamsD3D(&d3dpp, &devtype, &vertexproccesing);

	//      .
	if(hr != S_OK)
	{
		#ifdef SHOWHELP
			AfxMessageBox(" -     Direct3D");
		#endif
		
		return hr;
	}

	//    Direct3D,    .
	hr = m_pD3D->CreateDevice( D3DADAPTER_DEFAULT, devtype, m_hWnd,
								vertexproccesing, &d3dpp, &m_pd3dDevice);

	if(hr != S_OK)
	{
		
		#ifdef SHOWHELP
			AfxMessageBox(" -  Direct3D  !");
		#endif

		return hr;
	}


	return hr;
}


//     ,
//     /  Direct3D.
//       .
HRESULT CChildView::GetBestParamsD3D(D3DPRESENT_PARAMETERS* d3dpp, D3DDEVTYPE* pDevType, DWORD* pVertexProccesing)
{
	if(m_pD3D == NULL) return E_FAIL;

	HRESULT hr = S_OK;

	//     
	ZeroMemory( d3dpp, sizeof(D3DPRESENT_PARAMETERS) );

	//    .
	//      ,  
	//   ..    ,
	//       (CWnd::wndTopMost).
	d3dpp->Windowed = TRUE;
		
	
	D3DDISPLAYMODE display_mode;
	//     
	ZeroMemory( &display_mode, sizeof(D3DDISPLAYMODE) );

	//          ,
	//         
	//       
	hr = m_pD3D->GetAdapterDisplayMode(D3DADAPTER_DEFAULT, &display_mode);

	if(hr != S_OK)
	{
		#ifdef SHOWHELP
			AfxMessageBox(" -    !");
		#endif
		
		return hr;
	}


	//    -      ,
	//      3D .
	
	//       .
	D3DDEVTYPE devtype[] = 
	{
		D3DDEVTYPE_HAL,
		D3DDEVTYPE_REF,
		D3DDEVTYPE_NULLREF,
	};

	const UINT dt_count = sizeof(devtype) / sizeof(devtype[0]);

	//    .
	UINT index_devtype;
	for(index_devtype = 0; index_devtype < dt_count; index_devtype++)
	{
		if(m_pD3D->CheckDeviceType(D3DADAPTER_DEFAULT, 
										devtype[index_devtype], 
										display_mode.Format, 
										display_mode.Format, 
										TRUE) == S_OK)
		{
			if(pDevType != NULL)
			{
				*pDevType = devtype[index_devtype];
			}
			break;
		}
	}

	//         .
	if(pVertexProccesing != NULL)
	{
		*pVertexProccesing = 0;
		D3DCAPS9 caps;
		if(m_pD3D->GetDeviceCaps(D3DADAPTER_DEFAULT, devtype[index_devtype], &caps) == S_OK)
		{
			if((caps.DevCaps & D3DDEVCAPS_HWRASTERIZATION ) == D3DDEVCAPS_HWRASTERIZATION &&
				(caps.DevCaps & D3DDEVCAPS_HWTRANSFORMANDLIGHT) == D3DDEVCAPS_HWTRANSFORMANDLIGHT)
			{
				*pVertexProccesing |= D3DCREATE_HARDWARE_VERTEXPROCESSING;

				if((caps.DevCaps & D3DDEVCAPS_PUREDEVICE) == D3DDEVCAPS_PUREDEVICE)
					*pVertexProccesing |= D3DCREATE_PUREDEVICE;
			}
			else
			{
				*pVertexProccesing |= D3DCREATE_SOFTWARE_VERTEXPROCESSING;
			}
			
		}
	}// if(vertexproccesing != NULL)
	

	

	//    ,
	//         
	//  .
	const D3DFORMAT depth_format[] = 
	{
		D3DFMT_D32,
		D3DFMT_D24FS8,
		D3DFMT_D24X8,
		D3DFMT_D24S8, 
		D3DFMT_D24X4S4,
		D3DFMT_D16,
		D3DFMT_D15S1
	};

	const UINT ds_count = sizeof(depth_format) / sizeof(depth_format[0]);

	UINT index;
	for(index = 0; index < ds_count; index++)
	{
		//        
		//        , 
		//        .
		if( (hr = m_pD3D->CheckDepthStencilMatch(D3DADAPTER_DEFAULT, devtype[index_devtype], 
			display_mode.Format, display_mode.Format, depth_format[index])) == S_OK)
		{
			break;
		}
	}
		

	//        
	d3dpp->BackBufferFormat = display_mode.Format;

	//      Direct3D
	d3dpp->EnableAutoDepthStencil = TRUE;
	//        
	d3dpp->AutoDepthStencilFormat = depth_format[index];

	//       (. SDK DirectX C++)
	d3dpp->SwapEffect = D3DSWAPEFFECT_DISCARD;


	return hr;
}


HRESULT CChildView::Render(void)
{
	HRESULT hr = S_OK;

	if(m_pd3dDevice == NULL) return E_FAIL;


	m_DIMouse.ProcessingMouseEvent(this);
	
	
	//         
	hr = m_pd3dDevice->Clear(0, NULL, D3DCLEAR_TARGET|D3DCLEAR_ZBUFFER, m_Background.GetColorBG(), 1.0f, 0);

	if(hr != S_OK) return hr;
	
	//    
	hr = m_pd3dDevice->BeginScene();

	if(hr != S_OK) return hr;
	 
		   
	//  
	m_Background.Render(m_pd3dDevice);

	
	m_ControlButtons.Render(m_pd3dDevice, m_FullScreen);

	
	CRect rc;
	GetClientRect(&rc);
	m_ShowDataPlayers.Render(m_pd3dDevice, rc.right, rc.bottom);


	//  , 
	//   
	// -.
	D3DXMATRIX matX;
	D3DXMATRIX matY;
	D3DXMATRIX matZ;

	//  
	D3DXMatrixRotationAxis(&matY, &D3DXVECTOR3(0.0f, 1.0f, 0.0f), m_DIMouse.m_AngleY);
	D3DXMatrixRotationAxis(&matX, &D3DXVECTOR3(1.0f, 0.0f, 0.0f), m_DIMouse.m_AngleX);
	D3DXMatrixMultiply(&m_World, &matY, &matX);

	//  .
	D3DXMatrixTranslation(&matZ, 0, 0, m_DIMouse.m_ScaleZ);
	D3DXMatrixMultiply(&m_World, &m_World, &matZ);


	//    , , 
	//     .
	//      
	//  .
	if(m_IsActive == true)
	{
		if(m_CubeRube.RotateFrame() == true)
		{
			m_ShowDataPlayers.WriteRecordHolder();
		}
		m_CubeRube.Shuffle();
	}

	m_CubeRube.Render(m_pd3dDevice, m_World);


	//    
	hr = m_pd3dDevice->EndScene();
	if(hr != S_OK) return hr;

	//     
	hr = m_pd3dDevice->Present( NULL, NULL, NULL, NULL );

	//   ,   
	if(hr == D3DERR_DEVICELOST)
	{
		//      
		//      3D 
		if(m_pd3dDevice->TestCooperativeLevel() == D3DERR_DEVICENOTRESET)
		{
			ResetScene();
		}
	}

	//      
	//    .
	HANDLE g_h = CreateEvent(0, true, false, "1");
	WaitForSingleObject(g_h, 15);

	return hr;
}


//     Direct3D   .
//   , ,     
//    ,    
//        
//   .
//     3D     .
HRESULT CChildView::ResetScene(void)
{
	HRESULT hr = S_OK;


	hr = m_ShowDataPlayers.Invalidate();
	if(hr != S_OK) return hr;

	hr = m_ControlButtons.Invalidate();
	if(hr != S_OK) return hr;
			
	//  .
	D3DPRESENT_PARAMETERS d3dpp; 
	hr = GetBestParamsD3D(&d3dpp, NULL, NULL);

	//       Direct3D
	//       
	//   Direct3D
	if(hr != S_OK)
	{
		#ifdef SHOWHELP
			AfxMessageBox(" -     Direct3D");
		#endif
		
		return hr;
	}


	//     Direct3D
	//        
	// 3D 
	hr = m_pd3dDevice->Reset(&d3dpp);
	
		
	if(hr != S_OK)
	{
		#ifdef SHOWHELP
			AfxMessageBox(" -   /  Direct3D");
		#endif
		

		return hr;
	}
	
	//   ,   .
	SetupMatrices();


	//        ,
	// ..    
	//      
	//     
	m_pd3dDevice->SetRenderState(D3DRS_CULLMODE, D3DCULL_NONE);

	//       ,  ,
	//       
	//   " "
	m_pd3dDevice->SetRenderState( D3DRS_LIGHTING, FALSE );

	//      
	// 
	m_pd3dDevice->SetRenderState( D3DRS_ZENABLE, TRUE );




	hr = m_ControlButtons.Restore();
	if(hr != S_OK) return hr;
	
	hr = m_ShowDataPlayers.Restore();
	if(hr != S_OK) return hr;

	//     ,  .
	float x = (1.0f/m_matProj._11)*2.0f;
	float y = (1.0f/m_matProj._22)*2.0f;
	m_Background.Restore(x, y);


	return hr;
}


void CChildView::OnLButtonDown(UINT nFlags, CPoint point)
{
	if(m_FullScreen == TRUE)
		ClientToScreen(&point);
	int button_down = -1;
	m_ControlButtons.HandleMouse(point, &button_down, true);
	switch(button_down)
	{
	case CControlButtons::tbFullScreen:
	case CControlButtons::tbWindowed:
		OnFullscreen();
		break;
	case CControlButtons::tbNewGame:
		{
			m_CubeRube.DoShuffleRotation(69);
			m_ShowDataPlayers.StartGame();
		}
		break;
	case CControlButtons::tbEducation:
		{
		//   .
		m_ShowDataPlayers.StopGame();
		static int state = 0;
		m_CubeRube.StateCubeForEducation(state);
		state++;
		if(state > 2)
			state = 0;
		}
		break;
	case CControlButtons::tbReset:
		m_CubeRube.PrepareNewGame();
		m_ShowDataPlayers.StopGame();
		break;
	case CControlButtons::tbColorBG:
		m_Background.SetColorBG();
		break;
	case CControlButtons::tbColorFont:
		m_ShowDataPlayers.SetColorFont();
		break;
	case CControlButtons::tbImageBg:
		m_Background.LoadPicture(m_pd3dDevice);
		break;
	case CControlButtons::tbPlayerName:
		SetPlayerName();
		break;
	case CControlButtons::tbSetting:
		{
			CPreSettingDlg dlg;
			dlg.m_CounShuffleRotateEducation = m_CubeRube.m_CountShuffleRotateEducation;
			dlg.m_IsRequestPlayerName = m_IsRequestPlayerName;
			dlg.m_ShowNameStopWatch = m_ShowDataPlayers.m_ShowNameStopWatch;
			dlg.m_ShowListRecordHolders = m_ShowDataPlayers.m_ShowListRecordHolders;
			dlg.m_TransparentControlButtons = m_ControlButtons.m_TransparentControlButtons;
			if(dlg.DoModal() == IDOK)
			{
				m_CubeRube.m_CountShuffleRotateEducation = dlg.m_CounShuffleRotateEducation;
				m_IsRequestPlayerName = dlg.m_IsRequestPlayerName;
				m_ShowDataPlayers.m_ShowNameStopWatch = dlg.m_ShowNameStopWatch;
				m_ShowDataPlayers.m_ShowListRecordHolders = dlg.m_ShowListRecordHolders;
				m_ControlButtons.m_TransparentControlButtons = dlg.m_TransparentControlButtons;
			}
		}
		break;
	case CControlButtons::tbHelp:
		CWnd::OnHelpFinder();
		break;
	case CControlButtons::tbExit:
		{
			//       PostMessage,
			//       (   SendMessage()).
			AfxGetMainWnd()->PostMessage(WM_CLOSE, 0, 0);
		}
		break;
	
	}
	


	CWnd::OnLButtonDown(nFlags, point);
}

void CChildView::OnMouseMove(UINT nFlags, CPoint point)
{
	if(m_FullScreen == TRUE)
		ClientToScreen(&point);
	int temp = -1;
	m_ControlButtons.HandleMouse(point, &temp);
	

	CWnd::OnMouseMove(nFlags, point);
}

void CChildView::FromDIMouse(int btindex)
{
	
	switch(btindex)
	{
	case 1:
		m_CubeRube.PerformRotateFrame(this);
		break;
	
	case 3:
		m_CubeRube.BackRotate();
		break;
	}

}



void CChildView::OnFullscreen()
{
	static WINDOWPLACEMENT WndPlacement;

	static CMenu* pMenu = NULL;
	static bool full_screen = true;

	int screen_width  = GetSystemMetrics(SM_CXSCREEN);
	int screen_height = GetSystemMetrics(SM_CYSCREEN);

	if(full_screen == true)
	{
		//        
		AfxGetMainWnd()->GetWindowPlacement(&WndPlacement);

		//         .
		AfxGetMainWnd()->ModifyStyle(WS_OVERLAPPEDWINDOW, 0);

		//         .
		AfxGetMainWnd()->SetWindowPos(&CWnd::wndTop, 0,0, screen_width, screen_height, 0);

		m_FullScreen = TRUE;

	}
	else
	{
		m_FullScreen = FALSE;

		//        .
		AfxGetMainWnd()->ModifyStyle(0, WS_OVERLAPPEDWINDOW);

		//          
		//  ,         .
		CRect rc(&WndPlacement.rcNormalPosition);
		if(	rc.left < 50 && rc.top < 50 && 
			rc.right > (screen_width-50) && rc.bottom > (screen_height-50))
		{
			int left = screen_width/2  - 800/2;
			int top  = screen_height/2 - 600/2;
			SetRect(&WndPlacement.rcNormalPosition, left, top, left + 800, top + 600); 
			
		}
		WndPlacement.showCmd = SW_RESTORE;

		//    
		AfxGetMainWnd()->SetWindowPlacement(&WndPlacement);
	}

	full_screen = !full_screen;
}


void CChildView::DataToRegistry(void)
{
	HKEY hKey;
    if(ERROR_SUCCESS == RegCreateKeyEx( HKEY_CURRENT_USER, REGKEY, 
        0, NULL, REG_OPTION_NON_VOLATILE, KEY_SET_VALUE, NULL, &hKey, NULL))
    {
		GlobalNumberToRegKey(hKey, "RequestPlayerName", m_IsRequestPlayerName);

		m_Background.DataToRegistry(hKey);
		m_CubeRube.DataToRegistry(hKey);
		m_ShowDataPlayers.DataToRegistry(hKey);
		m_ControlButtons.DataToRegistry(hKey);
		
		RegCloseKey(hKey);
    }
}


void CChildView::DataFromRegistry(void)
{
	HKEY hKey;
    if(ERROR_SUCCESS == RegCreateKeyEx( HKEY_CURRENT_USER, REGKEY, 
        0, NULL, REG_OPTION_NON_VOLATILE, KEY_READ, NULL, &hKey, NULL))
    {
		GlobalNumberFromRegKey(hKey, "RequestPlayerName", (DWORD*)&m_IsRequestPlayerName, TRUE);

		m_Background.DataFromRegistry(hKey, m_pd3dDevice);
		m_CubeRube.DataFromRegistry(hKey);
		m_ShowDataPlayers.DataFromRegistry(hKey);
		m_ControlButtons.DataFromRegistry(hKey);

        RegCloseKey( hKey );
    }
}


void CChildView::OnMenuHelp()
{
	CWnd::OnHelpFinder();
}



void CChildView::OnLButtonUp(UINT nFlags, CPoint point)
{
	m_ControlButtons.m_IsDown = false;

	CWnd::OnLButtonUp(nFlags, point);
}

void CChildView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	switch(nChar)
	{
	case VK_F1:
		OnMenuHelp();
		break;
	case VK_F2:
		OnFullscreen();
		break;
	case VK_DELETE:
		//       R.
		if(HIBYTE(GetKeyState('R')) & 1)
		{
			m_ShowDataPlayers.DeleteListRecordHolders();
		}
		break;
	}


	CWnd::OnKeyDown(nChar, nRepCnt, nFlags);
}

