////////////////////////////////////////////////////////////////////////////////////
//
//			http://www.interestprograms.ru - ,     
//
/////////////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "CubeRubika3.h"
#include ".\cuberubika3.h"
#include <rmxfguid.h>
#include <rmxftmpl.h>
#include "ChildView.h"




CCubeRube::CCubeRube(void)
: m_pvbControl(NULL)
, m_pControlVertices(NULL)
, m_NumberFrame(0)
, m_IsRotate(false)
, m_pParent(NULL)
, m_pPsevdoMesh(NULL)
, m_IsShuffle(false)
, m_CountShuffleRotate(29)
, m_CountShuffleRotateEducation(3)
, m_pmatFramesMemory(NULL)
, m_ModeGame(false)
{
	//      
	//   
	//  .
	srand((unsigned)time(NULL));
}

CCubeRube::~CCubeRube(void)
{
	//  ,  -  CCubeRube. 

	delete[] m_pmatFramesMemory;

	for(int i = 0; i < (int)m_vecMatrixs.size(); i++)
	{
		SAFE_DELETE(m_vecMatrixs[i]);
	}

	for(int i = 0; i < (int)m_vecParseMesh.size(); i++)
	{
		//        ,
		//  -    :
		//         .
		for(int j = 0; j < (int)m_vecParseMesh[i]->dwNumMaterials; j++)
			SAFE_RELEASE(m_vecParseMesh[i]->pTextures[j]);

		SAFE_DELETE_ARRAY(m_vecParseMesh[i]->pTextures);
		SAFE_DELETE_ARRAY(m_vecParseMesh[i]->pMaterials);


		SAFE_RELEASE(m_vecParseMesh[i]->pMesh);
		SAFE_DELETE(m_vecParseMesh[i]);
	}

	SAFE_RELEASE(m_pPsevdoMesh);
	SAFE_RELEASE(m_pvbControl);
}


//  .     (    )
//     -   ,
//      , ,  
//    ,    ..
HRESULT CCubeRube::InitXFile(LPDIRECT3DDEVICE9 pd3dDevice, CWnd* pParent)
{
	//    ,
	//    IntersectFunction().
	m_pParent = pParent;

	HRESULT hr = S_OK;
	LPD3DXFILE pDXFile = NULL;

	//      ID3DXFile  ,
	//       (, )
	// 	  IDirectXFile - CreateEnumObject()
	hr = D3DXFileCreate(&pDXFile);
	if(hr != S_OK) return hr;


	//  DirectX SDK 2003 RegisterTemplates()     CreateEnumObject(),
	//  DirectX SDK 2007 RegisterTemplates()    
	//    ID3DXFile

	//     . ,   pDXFile->CreateEnumObject()
	//     .  
	//  (, , )   
	//    ,  
	// pDXFile->RegisterTemplates()
	hr = pDXFile->RegisterTemplates((void*)D3DRM_XTEMPLATES, D3DRM_XTEMPLATE_BYTES);
	if(hr != S_OK) return hr;


	
	LPD3DXFILEENUMOBJECT pEnumObj = NULL;
	D3DXF_FILELOADRESOURCE FileFromResource;
	//       
	// FileFromResource.hModule    NULL,
	//      .dll FileFromResource.hModule 
	//        .
	//  FileFromResource.hModule      
	//     .
	FileFromResource.hModule = AfxGetApp()->m_hInstance;
	FileFromResource.lpType  = "XFILES";
	FileFromResource.lpName  = MAKEINTRESOURCE(IDR_XCUBE);
	hr = pDXFile->CreateEnumObject((LPCVOID)&FileFromResource, D3DXF_FILELOAD_FROMRESOURCE, &pEnumObj);
	if(hr != S_OK) return hr;


	//   DirectX SDK 2007     ,
	//        DirectX SDK 2003
	LPD3DXFILEDATA pFileData = NULL;
	//  num        :
	//     GetChild() SIZE_T uiChild -  
	//     .
	SIZE_T num = 0;
	while(pEnumObj->GetChild(num, &pFileData) == S_OK)
	{
		GetMeshs(pd3dDevice, pFileData);
		num++;
	}


	//   ,      .
	pEnumObj->Release();
	pDXFile->Release();

	//         
	//   .
	m_pmatFramesMemory = new D3DXMATRIX[m_vecMatrixs.size()];


	//        
	//  .
	for(int i = 0; i < (int)m_vecMatrixs.size(); i++)
	{
		m_pmatFramesMemory[i] = *m_vecMatrixs[i];
	}

	//  ,     ,    
	//   , . IntersectFunction()
	hr = InitPsevdoMesh(pd3dDevice);
	if(hr != S_OK) return hr;


	//   ,     
	//           .
	hr  = InitControlVertex(pd3dDevice);
	if(hr != S_OK) return hr;


	return hr;
}


HRESULT CCubeRube::GetMeshs(LPDIRECT3DDEVICE9 pd3dDevice, LPD3DXFILEDATA pFileData)
{
	HRESULT hr = S_OK;
	GUID received_guid = {0};
	hr = pFileData->GetType(&received_guid);
	if(hr != S_OK) return hr;
	
	//     ,  .
	if(received_guid == TID_D3DRMMesh)
	{
		hr = LoadMesh(pd3dDevice, pFileData);
		if(hr != S_OK) return hr;
	}

	//    ,   
	//   .
	if(received_guid == TID_D3DRMFrameTransformMatrix)
	{
		D3DXMATRIX* pMatrix;
		SIZE_T size_t = sizeof(D3DXMATRIX);
		//      pFileData.
		hr = pFileData->Lock(&size_t, (LPCVOID*)&pMatrix);
		if(hr != S_OK) return hr;
		
		//        ,
		//       , 
		//       .
		D3DXMATRIX* pMemoryMatrix = new D3DXMATRIX;
		memcpy(pMemoryMatrix, pMatrix, sizeof(D3DXMATRIX));

		//        
		//   .  .
		//        
		//       .
		m_vecMatrixs.push_back(pMemoryMatrix);

		hr = pFileData->Unlock(); 
        if(hr != S_OK) return hr;
		
	}


	//   ,     LPD3DXFILEDATA	pFileData
	//   .       !
	if(received_guid == TID_D3DRMFrame)
	{
		LPD3DXFILEDATA   pChildData = NULL;
		DWORD num_child = 0;
		pFileData->GetChildren(&num_child);
		for(int i = 0; i < (int)num_child; i++)
		{
			hr = pFileData->GetChild(i, &pChildData); 
			if(hr != S_OK) return hr;

			GetMeshs(pd3dDevice, pChildData);
		}
	}

	//    .
	pFileData->Release();

	return hr;
}

HRESULT CCubeRube::LoadMesh(LPDIRECT3DDEVICE9 pd3dDevice, LPD3DXFILEDATA pFileData)
{
	HRESULT hr = D3D_OK;
	LPD3DXBUFFER pmtrlBuffer = NULL;
	LPD3DXBUFFER padjacencyBuffer = NULL;

	//    LPD3DXFILEDATA pFileData,   . .
	//    D3DXMESH_MANAGED,     D3D 
	//           D3D-.
	//          /
	//   D3D-.
	//           . 
	//     ,        ,
	//           .
	PARSEMESH* parse_mesh = new PARSEMESH;
	hr = D3DXLoadMeshFromXof(pFileData, D3DXMESH_MANAGED, pd3dDevice,
             &padjacencyBuffer/*  LPD3DXBUFFER    ,      */, 
								&pmtrlBuffer, NULL, &parse_mesh->dwNumMaterials, &parse_mesh->pMesh);
    if(hr != D3D_OK)
	{
		SAFE_DELETE(parse_mesh);
		goto free_memory;
	}


	if(pmtrlBuffer != NULL && parse_mesh->dwNumMaterials > 0)
    {
        //         .
        D3DXMATERIAL* d3dxMtrls = (D3DXMATERIAL*)pmtrlBuffer->GetBufferPointer();
        parse_mesh->pMaterials = new D3DMATERIAL9[parse_mesh->dwNumMaterials];
		
		
        if(parse_mesh->pMaterials == NULL)
		{
			SAFE_DELETE(parse_mesh);
			goto free_memory;
		}

        parse_mesh->pTextures = new LPDIRECT3DTEXTURE9[parse_mesh->dwNumMaterials];
        if(parse_mesh->pTextures == NULL)
		{
			SAFE_DELETE(parse_mesh);
			goto free_memory;
			
		}

        //        PARSEMESH,
		//     parse_mesh      . .
		//    m_vecParseMesh      .  
        for(DWORD i = 0; i < parse_mesh->dwNumMaterials; i++)
        {
            parse_mesh->pMaterials[i] = d3dxMtrls[i].MatD3D;
            parse_mesh->pTextures[i]  = NULL;

            //   .           .
			//   ""    ,    .
			//           
			//  .
            if(d3dxMtrls[i].pTextureFilename != NULL)
            {
				if(D3DXCreateTextureFromFile( pd3dDevice, d3dxMtrls[i].pTextureFilename, 
                                                       &parse_mesh->pTextures[i]) != S_OK)
				{
                    parse_mesh->pTextures[i] = NULL;
					
				}
				

            }//if( d3dxMtrls[i].pTextureFilename )
			
        }//for( DWORD i=0; i<m_dwNumMaterials; i++ )
    }
	
	//         .
	m_vecParseMesh.push_back(parse_mesh);


	//            
	// .
free_memory:
	SAFE_RELEASE(pmtrlBuffer);
	SAFE_RELEASE(padjacencyBuffer);

	return hr; 
}


//      :
//       
//          
// ,        
//   ,
//          
//            ,
//       .
//        -   ,   
//  .         ,
//     ,   ,   
//          .
HRESULT CCubeRube::InitPsevdoMesh(LPDIRECT3DDEVICE9 pd3dDevice)
{
	//     ,   
	//    3D- pd3dDevice
	HRESULT hr = S_OK;

	//          D3DXMESH_MANAGED, 
	//  	  LoadMesh()
	hr = D3DXLoadMeshFromXResource(AfxGetApp()->m_hInstance, MAKEINTRESOURCE(IDR_XCUBE), "XFILES", D3DXMESH_MANAGED,
									pd3dDevice, NULL, NULL, NULL, NULL, &m_pPsevdoMesh);


	return hr;
}



//   .
//     -  
//     
// .      
//      CalculateIntersect()
HRESULT CCubeRube::InitControlVertex(LPDIRECT3DDEVICE9 pd3dDevice)
{	
	HRESULT hr = S_OK;
	//  72  ,       216 
	hr = pd3dDevice->CreateVertexBuffer(216*sizeof(CUSTOMVERTEX_CONTROL),
												0, D3DFVF_CUSTOMVERTEX_CONTROL,
												D3DPOOL_MANAGED, &m_pvbControl, 0 );
	if(hr != S_OK) return hr;


	hr = m_pvbControl->Lock( 0, 0, (void**)&m_pControlVertices, 0);
	if(hr != S_OK) return hr;


	//  ,      
	//  .     
	//          .
	float add = 0.05f;


	// --------------------   --------------------------
	m_pControlVertices[0].vector3.x = -9.0f-add; m_pControlVertices[0].vector3.y = 9.01f+add; m_pControlVertices[0].vector3.z = -9.0f-add;
	m_pControlVertices[1].vector3.x = -9.0f-add; m_pControlVertices[1].vector3.y = 9.01f+add; m_pControlVertices[1].vector3.z = -3.0f-add;
	m_pControlVertices[2].vector3.x = -6.0f-add; m_pControlVertices[2].vector3.y = 9.01f+add; m_pControlVertices[2].vector3.z = -6.0f-add;
	
	m_pControlVertices[3].vector3.x = -9.0f-add; m_pControlVertices[3].vector3.y = 9.01f+add; m_pControlVertices[3].vector3.z = -3.0f-add;
	m_pControlVertices[4].vector3.x = -9.0f-add; m_pControlVertices[4].vector3.y = 9.01f+add; m_pControlVertices[4].vector3.z =  3.0f+add;
	m_pControlVertices[5].vector3.x = -6.0f-add; m_pControlVertices[5].vector3.y = 9.01f+add; m_pControlVertices[5].vector3.z =  0.0f;

	m_pControlVertices[6].vector3.x = -9.0f-add; m_pControlVertices[6].vector3.y = 9.01f+add; m_pControlVertices[6].vector3.z =  3.0f+add;
	m_pControlVertices[7].vector3.x = -9.0f-add; m_pControlVertices[7].vector3.y = 9.01f+add; m_pControlVertices[7].vector3.z =  9.0f+add;
	m_pControlVertices[8].vector3.x = -6.0f-add; m_pControlVertices[8].vector3.y = 9.01f+add; m_pControlVertices[8].vector3.z =  6.0f+add;

	m_pControlVertices[9].vector3.x  = -9.0f-add; m_pControlVertices[9].vector3.y = 9.01f+add;  m_pControlVertices[9].vector3.z =  9.0f+add;
	m_pControlVertices[10].vector3.x = -3.0f-add; m_pControlVertices[10].vector3.y = 9.01f+add; m_pControlVertices[10].vector3.z =  9.0f+add;
	m_pControlVertices[11].vector3.x = -6.0f-add; m_pControlVertices[11].vector3.y = 9.01f+add; m_pControlVertices[11].vector3.z =  6.0f+add;

	m_pControlVertices[12].vector3.x = -3.0f-add;m_pControlVertices[12].vector3.y = 9.01f+add;  m_pControlVertices[12].vector3.z =  9.0f+add;
	m_pControlVertices[13].vector3.x = 3.0f+add; m_pControlVertices[13].vector3.y = 9.01f+add; m_pControlVertices[13].vector3.z =  9.0f+add;
	m_pControlVertices[14].vector3.x = 0.0f;     m_pControlVertices[14].vector3.y = 9.01f+add; m_pControlVertices[14].vector3.z =  6.0f+add;

	m_pControlVertices[15].vector3.x = 3.0f+add; m_pControlVertices[15].vector3.y = 9.01f+add; m_pControlVertices[15].vector3.z =  9.0f+add;
	m_pControlVertices[16].vector3.x = 9.0f+add; m_pControlVertices[16].vector3.y = 9.01f+add; m_pControlVertices[16].vector3.z =  9.0f+add;
	m_pControlVertices[17].vector3.x = 6.0f+add; m_pControlVertices[17].vector3.y = 9.01f+add; m_pControlVertices[17].vector3.z =  6.0f+add;

	m_pControlVertices[18].vector3.x = 6.0f+add; m_pControlVertices[18].vector3.y = 9.01f+add; m_pControlVertices[18].vector3.z =  6.0f+add;
	m_pControlVertices[19].vector3.x = 9.0f+add; m_pControlVertices[19].vector3.y = 9.01f+add; m_pControlVertices[19].vector3.z =  9.0f+add;
	m_pControlVertices[20].vector3.x = 9.0f+add; m_pControlVertices[20].vector3.y = 9.01f+add; m_pControlVertices[20].vector3.z =  3.0f+add;

	m_pControlVertices[21].vector3.x = 6.0f+add; m_pControlVertices[21].vector3.y = 9.01f+add; m_pControlVertices[21].vector3.z =  0.0f;
	m_pControlVertices[22].vector3.x = 9.0f+add; m_pControlVertices[22].vector3.y = 9.01f+add; m_pControlVertices[22].vector3.z =  3.0f+add;
	m_pControlVertices[23].vector3.x = 9.0f+add; m_pControlVertices[23].vector3.y = 9.01f+add; m_pControlVertices[23].vector3.z =  -3.0f-add;

	m_pControlVertices[24].vector3.x = 6.0f+add; m_pControlVertices[24].vector3.y = 9.01f+add; m_pControlVertices[24].vector3.z =  -6.0f-add;
	m_pControlVertices[25].vector3.x = 9.0f+add; m_pControlVertices[25].vector3.y = 9.01f+add; m_pControlVertices[25].vector3.z =  -3.0f-add;
	m_pControlVertices[26].vector3.x = 9.0f+add; m_pControlVertices[26].vector3.y = 9.01f+add; m_pControlVertices[26].vector3.z =  -9.0f-add;
	
	m_pControlVertices[27].vector3.x = 6.0f+add; m_pControlVertices[27].vector3.y = 9.01f+add; m_pControlVertices[27].vector3.z =  -6.0f-add;
	m_pControlVertices[28].vector3.x = 9.0f+add; m_pControlVertices[28].vector3.y = 9.01f+add; m_pControlVertices[28].vector3.z =  -9.0f-add;
	m_pControlVertices[29].vector3.x = 3.0f+add; m_pControlVertices[29].vector3.y = 9.01f+add; m_pControlVertices[29].vector3.z =  -9.0f-add;

	m_pControlVertices[30].vector3.x = 0.0f; m_pControlVertices[30].vector3.y = 9.01f+add; m_pControlVertices[30].vector3.z =  -6.0f-add;
	m_pControlVertices[31].vector3.x = 3.0f+add; m_pControlVertices[31].vector3.y = 9.01f+add; m_pControlVertices[31].vector3.z =  -9.0f-add;
	m_pControlVertices[32].vector3.x = -3.0f-add; m_pControlVertices[32].vector3.y = 9.01f+add;m_pControlVertices[32].vector3.z =  -9.0f-add;

	m_pControlVertices[33].vector3.x = -6.0f-add; m_pControlVertices[33].vector3.y = 9.01f+add; m_pControlVertices[33].vector3.z =  -6.0f-add;
	m_pControlVertices[34].vector3.x = -3.0f-add; m_pControlVertices[34].vector3.y = 9.01f+add; m_pControlVertices[34].vector3.z =  -9.0f-add;
	m_pControlVertices[35].vector3.x = -9.0f-add; m_pControlVertices[35].vector3.y = 9.01f+add; m_pControlVertices[35].vector3.z =  -9.0f-add;
	
	// --------------------   --------------------------
	m_pControlVertices[36].vector3.x = -9.0f-add; m_pControlVertices[36].vector3.y = -3.0f-add; m_pControlVertices[36].vector3.z =  -9.01f-add;
	m_pControlVertices[37].vector3.x = -6.0f-add; m_pControlVertices[37].vector3.y = -6.0f-add; m_pControlVertices[37].vector3.z =  -9.01f-add;
	m_pControlVertices[38].vector3.x = -9.0f-add; m_pControlVertices[38].vector3.y = -9.0f-add; m_pControlVertices[38].vector3.z =  -9.01f-add;

	m_pControlVertices[39].vector3.x = -9.0f-add; m_pControlVertices[39].vector3.y = 3.0f+add;  m_pControlVertices[39].vector3.z =  -9.01f-add;
	m_pControlVertices[40].vector3.x = -6.0f-add; m_pControlVertices[40].vector3.y = 0.0f;      m_pControlVertices[40].vector3.z =  -9.01f-add;
	m_pControlVertices[41].vector3.x = -9.0f-add; m_pControlVertices[41].vector3.y = -3.0f-add; m_pControlVertices[41].vector3.z =  -9.01f-add;

	m_pControlVertices[42].vector3.x = -9.0f-add; m_pControlVertices[42].vector3.y = 9.0f+add; m_pControlVertices[42].vector3.z =  -9.01f-add;
	m_pControlVertices[43].vector3.x = -6.0f-add; m_pControlVertices[43].vector3.y = 6.0f+add; m_pControlVertices[43].vector3.z =  -9.01f-add;
	m_pControlVertices[44].vector3.x = -9.0f-add; m_pControlVertices[44].vector3.y = 3.0f+add; m_pControlVertices[44].vector3.z =  -9.01f-add;

	m_pControlVertices[45].vector3.x = -9.0f-add; m_pControlVertices[45].vector3.y = 9.0f+add; m_pControlVertices[45].vector3.z =  -9.01f-add;
	m_pControlVertices[46].vector3.x = -3.0f-add; m_pControlVertices[46].vector3.y = 9.0f+add; m_pControlVertices[46].vector3.z =  -9.01f-add;
	m_pControlVertices[47].vector3.x = -6.0f-add; m_pControlVertices[47].vector3.y = 6.0f+add; m_pControlVertices[47].vector3.z =  -9.01f-add;

	m_pControlVertices[48].vector3.x = -3.0f-add; m_pControlVertices[48].vector3.y = 9.0f+add; m_pControlVertices[48].vector3.z =  -9.01f-add;
	m_pControlVertices[49].vector3.x =  3.0f+add; m_pControlVertices[49].vector3.y = 9.0f+add; m_pControlVertices[49].vector3.z =  -9.01f-add;
	m_pControlVertices[50].vector3.x =  0.0f; m_pControlVertices[50].vector3.y = 6.0f+add; m_pControlVertices[50].vector3.z =  -9.01f-add;

	m_pControlVertices[51].vector3.x = 3.0f+add; m_pControlVertices[51].vector3.y = 9.0f+add; m_pControlVertices[51].vector3.z =  -9.01f-add;
	m_pControlVertices[52].vector3.x = 9.0f+add; m_pControlVertices[52].vector3.y = 9.0f+add; m_pControlVertices[52].vector3.z =  -9.01f-add;
	m_pControlVertices[53].vector3.x = 6.0f+add; m_pControlVertices[53].vector3.y = 6.0f+add; m_pControlVertices[53].vector3.z =  -9.01f-add;

	m_pControlVertices[54].vector3.x = 9.0f+add; m_pControlVertices[54].vector3.y = 9.0f+add; m_pControlVertices[54].vector3.z =  -9.01f-add;
	m_pControlVertices[55].vector3.x = 9.0f+add; m_pControlVertices[55].vector3.y = 3.0f+add; m_pControlVertices[55].vector3.z =  -9.01f-add;
	m_pControlVertices[56].vector3.x = 6.0f+add; m_pControlVertices[56].vector3.y = 6.0f+add; m_pControlVertices[56].vector3.z =  -9.01f-add;

	m_pControlVertices[57].vector3.x = 9.0f+add; m_pControlVertices[57].vector3.y = 3.0f+add;  m_pControlVertices[57].vector3.z =  -9.01f-add;
	m_pControlVertices[58].vector3.x = 9.0f+add; m_pControlVertices[58].vector3.y = -3.0f-add; m_pControlVertices[58].vector3.z = -9.01f-add;
	m_pControlVertices[59].vector3.x = 6.0f+add; m_pControlVertices[59].vector3.y = 0.0f;      m_pControlVertices[59].vector3.z =  -9.01f-add;

	m_pControlVertices[60].vector3.x = 9.0f+add; m_pControlVertices[60].vector3.y = -3.0f-add; m_pControlVertices[60].vector3.z =  -9.01f-add;
	m_pControlVertices[61].vector3.x = 9.0f+add; m_pControlVertices[61].vector3.y = -9.0f-add; m_pControlVertices[61].vector3.z =  -9.01f-add;
	m_pControlVertices[62].vector3.x = 6.0f+add; m_pControlVertices[62].vector3.y = -6.0f-add; m_pControlVertices[62].vector3.z =  -9.01f-add;

	m_pControlVertices[63].vector3.x = 9.0f+add; m_pControlVertices[63].vector3.y = -9.0f-add; m_pControlVertices[63].vector3.z =  -9.01f-add;
	m_pControlVertices[64].vector3.x = 3.0f+add; m_pControlVertices[64].vector3.y = -9.0f-add; m_pControlVertices[64].vector3.z =  -9.01f-add;
	m_pControlVertices[65].vector3.x = 6.0f+add; m_pControlVertices[65].vector3.y = -6.0f-add; m_pControlVertices[65].vector3.z =  -9.01f-add;

	m_pControlVertices[66].vector3.x = 3.0f+add; m_pControlVertices[66].vector3.y = -9.0f-add; m_pControlVertices[66].vector3.z =  -9.01f-add;
	m_pControlVertices[67].vector3.x = -3.0f-add;m_pControlVertices[67].vector3.y = -9.0f-add; m_pControlVertices[67].vector3.z =  -9.01f-add;
	m_pControlVertices[68].vector3.x = 0.0f;     m_pControlVertices[68].vector3.y = -6.0f-add; m_pControlVertices[68].vector3.z =  -9.01f-add;

	m_pControlVertices[69].vector3.x = -3.0f-add; m_pControlVertices[69].vector3.y = -9.0f-add; m_pControlVertices[69].vector3.z =  -9.01f-add;
	m_pControlVertices[70].vector3.x = -9.0f-add; m_pControlVertices[70].vector3.y = -9.0f-add; m_pControlVertices[70].vector3.z =  -9.01f-add;
	m_pControlVertices[71].vector3.x = -6.0f-add; m_pControlVertices[71].vector3.y = -6.0f-add; m_pControlVertices[71].vector3.z =  -9.01f-add;

	// --------------------   --------------------------
	m_pControlVertices[72].vector3.x = -9.01f-add; m_pControlVertices[72].vector3.y = -9.0f-add; m_pControlVertices[72].vector3.z =  9.0f+add;
	m_pControlVertices[73].vector3.x = -9.01f-add; m_pControlVertices[73].vector3.y = -3.0f-add; m_pControlVertices[73].vector3.z =  9.0f+add;
	m_pControlVertices[74].vector3.x = -9.01f-add; m_pControlVertices[74].vector3.y = -6.0f-add; m_pControlVertices[74].vector3.z =  6.0f+add;

	m_pControlVertices[75].vector3.x = -9.01f-add; m_pControlVertices[75].vector3.y = -3.0f-add; m_pControlVertices[75].vector3.z =  9.0f+add;
	m_pControlVertices[76].vector3.x = -9.01f-add; m_pControlVertices[76].vector3.y =  3.0f+add; m_pControlVertices[76].vector3.z =  9.0f+add;
	m_pControlVertices[77].vector3.x = -9.01f-add; m_pControlVertices[77].vector3.y =  0.0f;     m_pControlVertices[77].vector3.z =  6.0f+add;

	m_pControlVertices[78].vector3.x = -9.01f-add; m_pControlVertices[78].vector3.y =  3.0f+add; m_pControlVertices[78].vector3.z =  9.0f+add;
	m_pControlVertices[79].vector3.x = -9.01f-add; m_pControlVertices[79].vector3.y =  9.0f+add; m_pControlVertices[79].vector3.z =  9.0f+add;
	m_pControlVertices[80].vector3.x = -9.01f-add; m_pControlVertices[80].vector3.y =  6.0f+add; m_pControlVertices[80].vector3.z =  6.0f+add;

	m_pControlVertices[81].vector3.x = -9.01f-add; m_pControlVertices[81].vector3.y =  9.0f+add; m_pControlVertices[81].vector3.z =  9.0f+add;
	m_pControlVertices[82].vector3.x = -9.01f-add; m_pControlVertices[82].vector3.y =  9.0f+add; m_pControlVertices[82].vector3.z =  3.0f+add;
	m_pControlVertices[83].vector3.x = -9.01f-add; m_pControlVertices[83].vector3.y =  6.0f+add; m_pControlVertices[83].vector3.z =  6.0f+add;

	m_pControlVertices[84].vector3.x = -9.01f-add; m_pControlVertices[84].vector3.y =  9.0f+add; m_pControlVertices[84].vector3.z =  3.0f+add;
	m_pControlVertices[85].vector3.x = -9.01f-add; m_pControlVertices[85].vector3.y =  9.0f+add; m_pControlVertices[85].vector3.z =  -3.0f-add;
	m_pControlVertices[86].vector3.x = -9.01f-add; m_pControlVertices[86].vector3.y =  6.0f+add; m_pControlVertices[86].vector3.z =  0.0f;

	m_pControlVertices[87].vector3.x = -9.01f-add; m_pControlVertices[87].vector3.y =  9.0f+add; m_pControlVertices[87].vector3.z =  -3.0f-add;
	m_pControlVertices[88].vector3.x = -9.01f-add; m_pControlVertices[88].vector3.y =  9.0f+add; m_pControlVertices[88].vector3.z =  -9.0f-add;
	m_pControlVertices[89].vector3.x = -9.01f-add; m_pControlVertices[89].vector3.y =  6.0f+add; m_pControlVertices[89].vector3.z =  -6.0f-add;

	m_pControlVertices[90].vector3.x = -9.01f-add; m_pControlVertices[90].vector3.y =  9.0f+add; m_pControlVertices[90].vector3.z =  -9.0f-add;
	m_pControlVertices[91].vector3.x = -9.01f-add; m_pControlVertices[91].vector3.y =  3.0f+add; m_pControlVertices[91].vector3.z =  -9.0f-add;
	m_pControlVertices[92].vector3.x = -9.01f-add; m_pControlVertices[92].vector3.y =  6.0f+add; m_pControlVertices[92].vector3.z =  -6.0f-add;

	m_pControlVertices[93].vector3.x = -9.01f-add; m_pControlVertices[93].vector3.y =  3.0f+add; m_pControlVertices[93].vector3.z =  -9.0f-add;
	m_pControlVertices[94].vector3.x = -9.01f-add; m_pControlVertices[94].vector3.y = -3.0f-add; m_pControlVertices[94].vector3.z =  -9.0f-add;
	m_pControlVertices[95].vector3.x = -9.01f-add; m_pControlVertices[95].vector3.y =  0.0f;     m_pControlVertices[95].vector3.z =  -6.0f-add;

	m_pControlVertices[96].vector3.x = -9.01f-add; m_pControlVertices[96].vector3.y =  -3.0f-add; m_pControlVertices[96].vector3.z =  -9.0f-add;
	m_pControlVertices[97].vector3.x = -9.01f-add; m_pControlVertices[97].vector3.y =  -9.0f-add; m_pControlVertices[97].vector3.z =  -9.0f-add;
	m_pControlVertices[98].vector3.x = -9.01f-add; m_pControlVertices[98].vector3.y =  -6.0f-add; m_pControlVertices[98].vector3.z =  -6.0f-add;

	m_pControlVertices[99].vector3.x  = -9.01f-add;  m_pControlVertices[99].vector3.y =  -9.0f-add;  m_pControlVertices[99].vector3.z =  -9.0f-add;
	m_pControlVertices[100].vector3.x = -9.01f-add; m_pControlVertices[100].vector3.y =  -9.0f-add; m_pControlVertices[100].vector3.z =  -3.0f-add;
	m_pControlVertices[101].vector3.x = -9.01f-add; m_pControlVertices[101].vector3.y =  -6.0f-add; m_pControlVertices[101].vector3.z =  -6.0f-add;

	m_pControlVertices[102].vector3.x = -9.01f-add; m_pControlVertices[102].vector3.y =  -9.0f-add; m_pControlVertices[102].vector3.z =  -3.0f-add;
	m_pControlVertices[103].vector3.x = -9.01f-add; m_pControlVertices[103].vector3.y =  -9.0f-add; m_pControlVertices[103].vector3.z =  3.0f+add;
	m_pControlVertices[104].vector3.x = -9.01f-add; m_pControlVertices[104].vector3.y =  -6.0f-add; m_pControlVertices[104].vector3.z =  0.0f;

	m_pControlVertices[105].vector3.x = -9.01f-add; m_pControlVertices[105].vector3.y =  -9.0f-add; m_pControlVertices[105].vector3.z =  3.0f+add;
	m_pControlVertices[106].vector3.x = -9.01f-add; m_pControlVertices[106].vector3.y =  -9.0f-add; m_pControlVertices[106].vector3.z =  9.0f+add;
	m_pControlVertices[107].vector3.x = -9.01f-add; m_pControlVertices[107].vector3.y =  -6.0f-add; m_pControlVertices[107].vector3.z =  6.0f+add;

	
	// --------------------   -  --------------------------
	m_pControlVertices[108].vector3.x = -6.0f-add; m_pControlVertices[108].vector3.y =  -9.01f-add; m_pControlVertices[108].vector3.z =  -6.0f-add;
	m_pControlVertices[109].vector3.x = -9.0f-add; m_pControlVertices[109].vector3.y =  -9.01f-add; m_pControlVertices[109].vector3.z =  -3.0f-add;
	m_pControlVertices[110].vector3.x = -9.0f-add; m_pControlVertices[110].vector3.y =  -9.01f-add; m_pControlVertices[110].vector3.z =  -9.0f-add;

	m_pControlVertices[111].vector3.x = -6.0f-add; m_pControlVertices[111].vector3.y =  -9.01f-add; m_pControlVertices[111].vector3.z =   0.0f;
	m_pControlVertices[112].vector3.x = -9.0f-add; m_pControlVertices[112].vector3.y =  -9.01f-add; m_pControlVertices[112].vector3.z =   3.0f+add;
	m_pControlVertices[113].vector3.x = -9.0f-add; m_pControlVertices[113].vector3.y =  -9.01f-add; m_pControlVertices[113].vector3.z =  -3.0f-add;

	m_pControlVertices[114].vector3.x = -6.0f-add; m_pControlVertices[114].vector3.y =  -9.01f-add; m_pControlVertices[114].vector3.z =  6.0f+add;
	m_pControlVertices[115].vector3.x = -9.0f-add; m_pControlVertices[115].vector3.y =  -9.01f-add; m_pControlVertices[115].vector3.z =  9.0f+add;
	m_pControlVertices[116].vector3.x = -9.0f-add; m_pControlVertices[116].vector3.y =  -9.01f-add; m_pControlVertices[116].vector3.z =  3.0f+add;

	m_pControlVertices[117].vector3.x = -6.0f-add; m_pControlVertices[117].vector3.y =  -9.01f-add; m_pControlVertices[117].vector3.z =  6.0f+add;
	m_pControlVertices[118].vector3.x = -3.0f-add; m_pControlVertices[118].vector3.y =  -9.01f-add; m_pControlVertices[118].vector3.z =  9.0f+add;
	m_pControlVertices[119].vector3.x = -9.0f-add; m_pControlVertices[119].vector3.y =  -9.01f-add; m_pControlVertices[119].vector3.z =  9.0f+add;

	m_pControlVertices[120].vector3.x =  0.0f;     m_pControlVertices[120].vector3.y =  -9.01f-add; m_pControlVertices[120].vector3.z =  6.0f+add;
	m_pControlVertices[121].vector3.x =  3.0f+add; m_pControlVertices[121].vector3.y =  -9.01f-add; m_pControlVertices[121].vector3.z =  9.0f+add;
	m_pControlVertices[122].vector3.x = -3.0f-add; m_pControlVertices[122].vector3.y =  -9.01f-add; m_pControlVertices[122].vector3.z =  9.0f+add;

	m_pControlVertices[123].vector3.x =  6.0f+add; m_pControlVertices[123].vector3.y =  -9.01f-add; m_pControlVertices[123].vector3.z =  6.0f+add;
	m_pControlVertices[124].vector3.x =  9.0f+add; m_pControlVertices[124].vector3.y =  -9.01f-add; m_pControlVertices[124].vector3.z =  9.0f+add;
	m_pControlVertices[125].vector3.x =  3.0f+add; m_pControlVertices[125].vector3.y =  -9.01f-add; m_pControlVertices[125].vector3.z =  9.0f+add;

	m_pControlVertices[126].vector3.x =  9.0f+add; m_pControlVertices[126].vector3.y =  -9.01f-add; m_pControlVertices[126].vector3.z =  3.0f+add;
	m_pControlVertices[127].vector3.x =  9.0f+add; m_pControlVertices[127].vector3.y =  -9.01f-add; m_pControlVertices[127].vector3.z =  9.0f+add;
	m_pControlVertices[128].vector3.x =  6.0f+add; m_pControlVertices[128].vector3.y =  -9.01f-add; m_pControlVertices[128].vector3.z =  6.0f+add;

	m_pControlVertices[129].vector3.x =  9.0f+add; m_pControlVertices[129].vector3.y =  -9.01f-add; m_pControlVertices[129].vector3.z = -3.0f-add;
	m_pControlVertices[130].vector3.x =  9.0f+add; m_pControlVertices[130].vector3.y =  -9.01f-add; m_pControlVertices[130].vector3.z =  3.0f+add;
	m_pControlVertices[131].vector3.x =  6.0f+add; m_pControlVertices[131].vector3.y =  -9.01f-add; m_pControlVertices[131].vector3.z =  0.0f;

	m_pControlVertices[132].vector3.x =  9.0f+add; m_pControlVertices[132].vector3.y =  -9.01f-add; m_pControlVertices[132].vector3.z = -9.0f-add;
	m_pControlVertices[133].vector3.x =  9.0f+add; m_pControlVertices[133].vector3.y =  -9.01f-add; m_pControlVertices[133].vector3.z = -3.0f-add;
	m_pControlVertices[134].vector3.x =  6.0f+add; m_pControlVertices[134].vector3.y =  -9.01f-add; m_pControlVertices[134].vector3.z = -6.0f-add;

	m_pControlVertices[135].vector3.x =  3.0f+add; m_pControlVertices[135].vector3.y =  -9.01f-add; m_pControlVertices[135].vector3.z = -9.0f-add;
	m_pControlVertices[136].vector3.x =  9.0f+add; m_pControlVertices[136].vector3.y =  -9.01f-add; m_pControlVertices[136].vector3.z = -9.0f-add;
	m_pControlVertices[137].vector3.x =  6.0f+add; m_pControlVertices[137].vector3.y =  -9.01f-add; m_pControlVertices[137].vector3.z = -6.0f-add;

	m_pControlVertices[138].vector3.x = -3.0f-add; m_pControlVertices[138].vector3.y =  -9.01f-add; m_pControlVertices[138].vector3.z = -9.0f-add;
	m_pControlVertices[139].vector3.x =  3.0f+add; m_pControlVertices[139].vector3.y =  -9.01f-add; m_pControlVertices[139].vector3.z = -9.0f-add;
	m_pControlVertices[140].vector3.x =  0.0f;     m_pControlVertices[140].vector3.y =  -9.01f-add; m_pControlVertices[140].vector3.z = -6.0f-add;

	m_pControlVertices[141].vector3.x = -9.0f-add; m_pControlVertices[141].vector3.y =  -9.01f-add; m_pControlVertices[141].vector3.z = -9.0f-add;
	m_pControlVertices[142].vector3.x = -3.0f-add; m_pControlVertices[142].vector3.y =  -9.01f-add; m_pControlVertices[142].vector3.z = -9.0f-add;
	m_pControlVertices[143].vector3.x = -6.0f-add; m_pControlVertices[143].vector3.y =  -9.01f-add; m_pControlVertices[143].vector3.z = -6.0f-add;


	// --------------------   -   --------------------------
	m_pControlVertices[144].vector3.x = -9.0f-add; m_pControlVertices[144].vector3.y =  -9.0f-add; m_pControlVertices[144].vector3.z = 9.01f+add;
	m_pControlVertices[145].vector3.x = -6.0f-add; m_pControlVertices[145].vector3.y =  -6.0f-add; m_pControlVertices[145].vector3.z = 9.01f+add;
	m_pControlVertices[146].vector3.x = -9.0f-add; m_pControlVertices[146].vector3.y =  -3.0f-add; m_pControlVertices[146].vector3.z = 9.01f+add;

	m_pControlVertices[147].vector3.x = -9.0f-add; m_pControlVertices[147].vector3.y =  -3.0f-add; m_pControlVertices[147].vector3.z = 9.01f+add;
	m_pControlVertices[148].vector3.x = -6.0f-add; m_pControlVertices[148].vector3.y =   0.0f; m_pControlVertices[148].vector3.z = 9.01f+add;
	m_pControlVertices[149].vector3.x = -9.0f-add; m_pControlVertices[149].vector3.y =   3.0f+add; m_pControlVertices[149].vector3.z = 9.01f+add;

	m_pControlVertices[150].vector3.x = -9.0f-add; m_pControlVertices[150].vector3.y =   3.0f+add; m_pControlVertices[150].vector3.z = 9.01f+add;
	m_pControlVertices[151].vector3.x = -6.0f-add; m_pControlVertices[151].vector3.y =   6.0f+add; m_pControlVertices[151].vector3.z = 9.01f+add;
	m_pControlVertices[152].vector3.x = -9.0f-add; m_pControlVertices[152].vector3.y =   9.0f+add; m_pControlVertices[152].vector3.z = 9.01f+add;

	m_pControlVertices[153].vector3.x = -6.0f-add; m_pControlVertices[153].vector3.y =   6.0f+add; m_pControlVertices[153].vector3.z = 9.01f+add;
	m_pControlVertices[154].vector3.x = -3.0f-add; m_pControlVertices[154].vector3.y =   9.0f+add; m_pControlVertices[154].vector3.z = 9.01f+add;
	m_pControlVertices[155].vector3.x = -9.0f-add; m_pControlVertices[155].vector3.y =   9.0f+add; m_pControlVertices[155].vector3.z = 9.01f+add;

	m_pControlVertices[156].vector3.x =  0.0f;     m_pControlVertices[156].vector3.y =   6.0f+add; m_pControlVertices[156].vector3.z = 9.01f+add;
	m_pControlVertices[157].vector3.x =  3.0f+add; m_pControlVertices[157].vector3.y =   9.0f+add; m_pControlVertices[157].vector3.z = 9.01f+add;
	m_pControlVertices[158].vector3.x = -3.0f-add; m_pControlVertices[158].vector3.y =   9.0f+add; m_pControlVertices[158].vector3.z = 9.01f+add;

	m_pControlVertices[159].vector3.x =  6.0f+add; m_pControlVertices[159].vector3.y =   6.0f+add; m_pControlVertices[159].vector3.z = 9.01f+add;
	m_pControlVertices[160].vector3.x =  9.0f+add; m_pControlVertices[160].vector3.y =   9.0f+add; m_pControlVertices[160].vector3.z = 9.01f+add;
	m_pControlVertices[161].vector3.x =  3.0f+add; m_pControlVertices[161].vector3.y =   9.0f+add; m_pControlVertices[161].vector3.z = 9.01f+add;

	m_pControlVertices[162].vector3.x =  6.0f+add; m_pControlVertices[162].vector3.y =   6.0f+add; m_pControlVertices[162].vector3.z = 9.01f+add;
	m_pControlVertices[163].vector3.x =  9.0f+add; m_pControlVertices[163].vector3.y =   3.0f+add; m_pControlVertices[163].vector3.z = 9.01f+add;
	m_pControlVertices[164].vector3.x =  9.0f+add; m_pControlVertices[164].vector3.y =   9.0f+add; m_pControlVertices[164].vector3.z = 9.01f+add;

	m_pControlVertices[165].vector3.x =  6.0f+add; m_pControlVertices[165].vector3.y =   0.0f; m_pControlVertices[165].vector3.z = 9.01f+add;
	m_pControlVertices[166].vector3.x =  9.0f+add; m_pControlVertices[166].vector3.y =  -3.0f-add; m_pControlVertices[166].vector3.z = 9.01f+add;
	m_pControlVertices[167].vector3.x =  9.0f+add; m_pControlVertices[167].vector3.y =   3.0f+add; m_pControlVertices[167].vector3.z = 9.01f+add;

	m_pControlVertices[168].vector3.x =  6.0f+add; m_pControlVertices[168].vector3.y =  -6.0f-add; m_pControlVertices[168].vector3.z = 9.01f+add;
	m_pControlVertices[169].vector3.x =  9.0f+add; m_pControlVertices[169].vector3.y =  -9.0f-add; m_pControlVertices[169].vector3.z = 9.01f+add;
	m_pControlVertices[170].vector3.x =  9.0f+add; m_pControlVertices[170].vector3.y =  -3.0f-add; m_pControlVertices[170].vector3.z = 9.01f+add;

	m_pControlVertices[171].vector3.x =  6.0f+add; m_pControlVertices[171].vector3.y =  -6.0f-add; m_pControlVertices[171].vector3.z = 9.01f+add;
	m_pControlVertices[172].vector3.x =  3.0f+add; m_pControlVertices[172].vector3.y =  -9.0f-add; m_pControlVertices[172].vector3.z = 9.01f+add;
	m_pControlVertices[173].vector3.x =  9.0f+add; m_pControlVertices[173].vector3.y =  -9.0f-add; m_pControlVertices[173].vector3.z = 9.01f+add;

	m_pControlVertices[174].vector3.x =  0.0f;     m_pControlVertices[174].vector3.y =  -6.0f-add; m_pControlVertices[174].vector3.z = 9.01f+add;
	m_pControlVertices[175].vector3.x = -3.0f-add; m_pControlVertices[175].vector3.y =  -9.0f-add; m_pControlVertices[175].vector3.z = 9.01f+add;
	m_pControlVertices[176].vector3.x =  3.0f+add; m_pControlVertices[176].vector3.y =  -9.0f-add; m_pControlVertices[176].vector3.z = 9.01f+add;

	m_pControlVertices[177].vector3.x = -6.0f-add; m_pControlVertices[177].vector3.y =  -6.0f-add; m_pControlVertices[177].vector3.z = 9.01f+add;
	m_pControlVertices[178].vector3.x = -9.0f-add; m_pControlVertices[178].vector3.y =  -9.0f-add; m_pControlVertices[178].vector3.z = 9.01f+add;
	m_pControlVertices[179].vector3.x = -3.0f-add; m_pControlVertices[179].vector3.y =  -9.0f-add; m_pControlVertices[179].vector3.z = 9.01f+add;


	// --------------------   -   --------------------------
	m_pControlVertices[180].vector3.x =  9.01f+add; m_pControlVertices[180].vector3.y =  -6.0f-add; m_pControlVertices[180].vector3.z = 6.0f+add;
	m_pControlVertices[181].vector3.x =  9.01f+add; m_pControlVertices[181].vector3.y =  -3.0f-add; m_pControlVertices[181].vector3.z = 9.0f+add;
	m_pControlVertices[182].vector3.x =  9.01f+add; m_pControlVertices[182].vector3.y =  -9.0f-add; m_pControlVertices[182].vector3.z = 9.0f+add;

	m_pControlVertices[183].vector3.x =  9.01f+add; m_pControlVertices[183].vector3.y =   0.0f; m_pControlVertices[183].vector3.z = 6.0f+add;
	m_pControlVertices[184].vector3.x =  9.01f+add; m_pControlVertices[184].vector3.y =   3.0f+add; m_pControlVertices[184].vector3.z = 9.0f+add;
	m_pControlVertices[185].vector3.x =  9.01f+add; m_pControlVertices[185].vector3.y =  -3.0f-add; m_pControlVertices[185].vector3.z = 9.0f+add;

	m_pControlVertices[186].vector3.x =  9.01f+add; m_pControlVertices[186].vector3.y =   6.0f+add; m_pControlVertices[186].vector3.z = 6.0f+add;
	m_pControlVertices[187].vector3.x =  9.01f+add; m_pControlVertices[187].vector3.y =   9.0f+add; m_pControlVertices[187].vector3.z = 9.0f+add;
	m_pControlVertices[188].vector3.x =  9.01f+add; m_pControlVertices[188].vector3.y =   3.0f+add; m_pControlVertices[188].vector3.z = 9.0f+add;

	m_pControlVertices[189].vector3.x =  9.01f+add; m_pControlVertices[189].vector3.y =   6.0f+add; m_pControlVertices[189].vector3.z = 6.0f+add;
	m_pControlVertices[190].vector3.x =  9.01f+add; m_pControlVertices[190].vector3.y =   9.0f+add; m_pControlVertices[190].vector3.z = 3.0f+add;
	m_pControlVertices[191].vector3.x =  9.01f+add; m_pControlVertices[191].vector3.y =   9.0f+add; m_pControlVertices[191].vector3.z = 9.0f+add;

	m_pControlVertices[192].vector3.x =  9.01f+add; m_pControlVertices[192].vector3.y =   6.0f+add; m_pControlVertices[192].vector3.z = 0.0f;
	m_pControlVertices[193].vector3.x =  9.01f+add; m_pControlVertices[193].vector3.y =   9.0f+add; m_pControlVertices[193].vector3.z = -3.0f-add;
	m_pControlVertices[194].vector3.x =  9.01f+add; m_pControlVertices[194].vector3.y =   9.0f+add; m_pControlVertices[194].vector3.z = 3.0f+add;

	m_pControlVertices[195].vector3.x =  9.01f+add; m_pControlVertices[195].vector3.y =   6.0f+add; m_pControlVertices[195].vector3.z = -6.0f-add;
	m_pControlVertices[196].vector3.x =  9.01f+add; m_pControlVertices[196].vector3.y =   9.0f+add; m_pControlVertices[196].vector3.z = -9.0f-add;
	m_pControlVertices[197].vector3.x =  9.01f+add; m_pControlVertices[197].vector3.y =   9.0f+add; m_pControlVertices[197].vector3.z = -3.0f-add;

	m_pControlVertices[198].vector3.x =  9.01f+add; m_pControlVertices[198].vector3.y =   6.0f+add; m_pControlVertices[198].vector3.z = -6.0f-add;
	m_pControlVertices[199].vector3.x =  9.01f+add; m_pControlVertices[199].vector3.y =   3.0f+add; m_pControlVertices[199].vector3.z = -9.0f-add;
	m_pControlVertices[200].vector3.x =  9.01f+add; m_pControlVertices[200].vector3.y =   9.0f+add; m_pControlVertices[200].vector3.z = -9.0f-add;

	m_pControlVertices[201].vector3.x =  9.01f+add; m_pControlVertices[201].vector3.y =   0.0f; m_pControlVertices[201].vector3.z = -6.0f-add;
	m_pControlVertices[202].vector3.x =  9.01f+add; m_pControlVertices[202].vector3.y =  -3.0f-add; m_pControlVertices[202].vector3.z = -9.0f-add;
	m_pControlVertices[203].vector3.x =  9.01f+add; m_pControlVertices[203].vector3.y =   3.0f+add; m_pControlVertices[203].vector3.z = -9.0f-add;

	m_pControlVertices[204].vector3.x =  9.01f+add; m_pControlVertices[204].vector3.y =  -6.0f-add; m_pControlVertices[204].vector3.z = -6.0f-add;
	m_pControlVertices[205].vector3.x =  9.01f+add; m_pControlVertices[205].vector3.y =  -9.0f-add; m_pControlVertices[205].vector3.z = -9.0f-add;
	m_pControlVertices[206].vector3.x =  9.01f+add; m_pControlVertices[206].vector3.y =  -3.0f-add; m_pControlVertices[206].vector3.z = -9.0f-add;

	m_pControlVertices[207].vector3.x =  9.01f+add; m_pControlVertices[207].vector3.y =  -6.0f-add; m_pControlVertices[207].vector3.z = -6.0f-add;
	m_pControlVertices[208].vector3.x =  9.01f+add; m_pControlVertices[208].vector3.y =  -9.0f-add; m_pControlVertices[208].vector3.z = -3.0f-add;
	m_pControlVertices[209].vector3.x =  9.01f+add; m_pControlVertices[209].vector3.y =  -9.0f-add; m_pControlVertices[209].vector3.z = -9.0f-add;

	m_pControlVertices[210].vector3.x =  9.01f+add; m_pControlVertices[210].vector3.y =  -6.0f-add; m_pControlVertices[210].vector3.z =  0.0f;
	m_pControlVertices[211].vector3.x =  9.01f+add; m_pControlVertices[211].vector3.y =  -9.0f-add; m_pControlVertices[211].vector3.z =  3.0f+add;
	m_pControlVertices[212].vector3.x =  9.01f+add; m_pControlVertices[212].vector3.y =  -9.0f-add; m_pControlVertices[212].vector3.z = -3.0f-add;

	m_pControlVertices[213].vector3.x =  9.01f+add; m_pControlVertices[213].vector3.y =  -6.0f-add; m_pControlVertices[213].vector3.z =  6.0f+add;
	m_pControlVertices[214].vector3.x =  9.01f+add; m_pControlVertices[214].vector3.y =  -9.0f-add; m_pControlVertices[214].vector3.z =  9.0f+add;
	m_pControlVertices[215].vector3.x =  9.01f+add; m_pControlVertices[215].vector3.y =  -9.0f-add; m_pControlVertices[215].vector3.z =  3.0f+add;


	hr = m_pvbControl->Unlock();

	return hr;
}

//    
//       Z.
BOOL SORT(DATAINTERSECT data1, DATAINTERSECT data2)
{
	return data1.distance < data2.distance;
}

//          .
BOOL CCubeRube::CalculateIntersect(int width, int height, D3DXMATRIX world, 
								  D3DXMATRIX view, D3DXMATRIX proj, int* number_rotate)
{

	D3DXVECTOR3 vPickRayDir;
	D3DXVECTOR3 vPickRayOrig;


	POINT ptCursor;
	GetCursorPos( &ptCursor );

	CChildView* pParent = (CChildView*)m_pParent;
	if(pParent == NULL) return FALSE;

	pParent->ScreenToClient(&ptCursor );


	//       
	//       3D .
	//     SDK DirectX9.
	//   3D     
	//   "    Windows".
	//       ,  
	//  ,     ,
	//   .    DirectX, OpenGL
	//       .

	//     
	//      .
	//     
	//       .
	D3DXVECTOR3 v;
	v.x = (((2.0f * ptCursor.x)/width) - 1)/proj._11; //      proj._11
	v.y =  -((( 2.0f * ptCursor.y)/height) - 1)/proj._22;
	v.z =  1.0f;

	D3DXMATRIXA16 m;
	m = world * view;
	D3DXMatrixInverse(&m, NULL, &m);

	//    
	//     .
	vPickRayDir.x  = v.x*m._11 + v.y*m._21 + v.z*m._31;
	vPickRayDir.y  = v.x*m._12 + v.y*m._22 + v.z*m._32;
	vPickRayDir.z  = v.x*m._13 + v.y*m._23 + v.z*m._33;
	vPickRayOrig.x = m._41;
	vPickRayOrig.y = m._42;
	vPickRayOrig.z = m._43;

	
	std::vector<DATAINTERSECT> vecData;

	FLOAT fBary1, fBary2, fDist;

	
	CString s, S;
	BOOL IsMesh = FALSE;
	DWORD dwFace;

 	
	if(D3DXIntersect(m_pPsevdoMesh, &vPickRayOrig, &vPickRayDir, &IsMesh, 
						&dwFace, &fBary1, &fBary2, &fDist, NULL, NULL) != S_OK)
		return FALSE;


	if(IsMesh == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = -1;
		vecData.push_back(data);
	}




	///////////////////////////////////////////////////////////////////////
	//  
	if(D3DXIntersectTri(	&m_pControlVertices[0].vector3, // 1 
							&m_pControlVertices[1].vector3, 
							&m_pControlVertices[2].vector3,  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 1;
		vecData.push_back(data);
	}

			


	if(D3DXIntersectTri(	&m_pControlVertices[3].vector3, // 2
							&m_pControlVertices[4].vector3, 
							&m_pControlVertices[5].vector3,  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 2;
		vecData.push_back(data);
	}

	

	if(D3DXIntersectTri(	&m_pControlVertices[6].vector3, // 3
							&m_pControlVertices[7].vector3, 
							&m_pControlVertices[8].vector3,  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{

		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 3;
		vecData.push_back(data);
	}


	if(D3DXIntersectTri(	&m_pControlVertices[9].vector3, // 4
							&m_pControlVertices[10].vector3, 
							&m_pControlVertices[11].vector3,  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 4;
		vecData.push_back(data);
	}


	if(D3DXIntersectTri(	&m_pControlVertices[12].vector3, // 5
							&m_pControlVertices[13].vector3, 
							&m_pControlVertices[14].vector3,  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 5;
		vecData.push_back(data);
	}



	if(D3DXIntersectTri(	&m_pControlVertices[15].vector3, // 6
							&m_pControlVertices[16].vector3, 
							&m_pControlVertices[17].vector3,  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 6; 
		vecData.push_back(data);
	}

	
	if(D3DXIntersectTri(	&m_pControlVertices[18].vector3, // 7
							&m_pControlVertices[19].vector3, 
							&m_pControlVertices[20].vector3,  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 7;
		vecData.push_back(data);
	}
	

	if(D3DXIntersectTri(	&m_pControlVertices[21].vector3, // 8
						    &m_pControlVertices[22].vector3, 
							&m_pControlVertices[23].vector3,  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 8;
		vecData.push_back(data);
	}
	

	if(D3DXIntersectTri(	&m_pControlVertices[24].vector3, // 9
							&m_pControlVertices[25].vector3, 
							&m_pControlVertices[26].vector3,  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 9;
		vecData.push_back(data);
	}
	

	if(D3DXIntersectTri(	&m_pControlVertices[27].vector3, // 10
							&m_pControlVertices[28].vector3, 
							&m_pControlVertices[29].vector3,  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 10;
		vecData.push_back(data);
	}
	

	if(D3DXIntersectTri(	&m_pControlVertices[30].vector3, // 11
							&m_pControlVertices[31].vector3, 
							&m_pControlVertices[32].vector3,  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 11;
		vecData.push_back(data);
	}
	

	if(D3DXIntersectTri(	&m_pControlVertices[33].vector3, // 12
							&m_pControlVertices[34].vector3, 
							&m_pControlVertices[35].vector3,  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 12;
		vecData.push_back(data);
	}


	///////////////////////////////////////////////////////////////////////////
	//  

	if(D3DXIntersectTri(	&m_pControlVertices[36].vector3, // 13
							&m_pControlVertices[37].vector3, 
							&m_pControlVertices[38].vector3,  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 13;
		vecData.push_back(data);
	}
	

	if(D3DXIntersectTri(	&m_pControlVertices[39].vector3, // 14
							&m_pControlVertices[40].vector3, 
							&m_pControlVertices[41].vector3,  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 14;
		vecData.push_back(data);
	}
	

	if(D3DXIntersectTri(	&m_pControlVertices[42].vector3, // 15
							&m_pControlVertices[43].vector3, 
							&m_pControlVertices[44].vector3,  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 15;
		vecData.push_back(data);
	}
	

	if(D3DXIntersectTri(	&m_pControlVertices[45].vector3, // 16
							&m_pControlVertices[46].vector3, 
							&m_pControlVertices[47].vector3,  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 4;
		vecData.push_back(data);
	}
	

	if(D3DXIntersectTri(	&m_pControlVertices[48].vector3, // 17
							&m_pControlVertices[49].vector3, 
							&m_pControlVertices[50].vector3,  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 5;
		vecData.push_back(data);
	}
	

	if(D3DXIntersectTri(	&m_pControlVertices[51].vector3, // 18
							&m_pControlVertices[52].vector3, 
							&m_pControlVertices[53].vector3,  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 6;
		vecData.push_back(data);
	}
	

	if(D3DXIntersectTri(	&m_pControlVertices[54].vector3, // 19
							&m_pControlVertices[55].vector3, 
							&m_pControlVertices[56].vector3,  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 16;
		vecData.push_back(data);
	}
	

	if(D3DXIntersectTri(	&m_pControlVertices[57].vector3, // 20
							&m_pControlVertices[58].vector3, 
							&m_pControlVertices[59].vector3,  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 17;
		vecData.push_back(data);
	}
	

	if(D3DXIntersectTri(	&m_pControlVertices[60].vector3, // 21
							&m_pControlVertices[61].vector3, 
							&m_pControlVertices[62].vector3,  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 18;
		vecData.push_back(data);
	}
	

	if(D3DXIntersectTri(	&m_pControlVertices[63].vector3, // 22
							&m_pControlVertices[64].vector3, 
							&m_pControlVertices[65].vector3,  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 10;
		vecData.push_back(data);
	}
	

	if(D3DXIntersectTri(	&m_pControlVertices[66].vector3, // 23
							&m_pControlVertices[67].vector3, 
							&m_pControlVertices[68].vector3,  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 11;
		vecData.push_back(data);
	}
	

	if(D3DXIntersectTri(	&m_pControlVertices[69].vector3, // 24
							&m_pControlVertices[70].vector3, 
							&m_pControlVertices[71].vector3,  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 12;
		vecData.push_back(data);
	}
	

	///////////////////////////////////////////////////////////////////////////
	//  

	if(D3DXIntersectTri(	&m_pControlVertices[72].vector3, // 25
							&m_pControlVertices[73].vector3, 
							&m_pControlVertices[74].vector3,  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 13;
		vecData.push_back(data);
	}


	if(D3DXIntersectTri(	&m_pControlVertices[75].vector3, // 26
							&m_pControlVertices[76].vector3, 
							&m_pControlVertices[77].vector3,  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 14;
		vecData.push_back(data);
	}


	if(D3DXIntersectTri(	&m_pControlVertices[78].vector3, // 27
							&m_pControlVertices[79].vector3, 
							&m_pControlVertices[80].vector3,  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 15;
		vecData.push_back(data);
	}


	if(D3DXIntersectTri(	&m_pControlVertices[81].vector3, // 28
							&m_pControlVertices[82].vector3, 
							&m_pControlVertices[83].vector3,  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 7;
		vecData.push_back(data);
	}


	if(D3DXIntersectTri(	&m_pControlVertices[84].vector3, // 29
							&m_pControlVertices[85].vector3, 
							&m_pControlVertices[86].vector3,  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 8;
		vecData.push_back(data);
	}


	if(D3DXIntersectTri(	&m_pControlVertices[87].vector3, // 30
							&m_pControlVertices[88].vector3, 
							&m_pControlVertices[89].vector3,  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 9;
		vecData.push_back(data);
	}
	

	if(D3DXIntersectTri(	&m_pControlVertices[90].vector3, // 31
							&m_pControlVertices[91].vector3, 
							&m_pControlVertices[92].vector3,  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 16;
		vecData.push_back(data);
	}


	if(D3DXIntersectTri(	&m_pControlVertices[93].vector3, // 32
							&m_pControlVertices[94].vector3, 
							&m_pControlVertices[95].vector3,  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 17;
		vecData.push_back(data);
	}
	

	if(D3DXIntersectTri(	&m_pControlVertices[96].vector3, // 33
							&m_pControlVertices[97].vector3, 
							&m_pControlVertices[98].vector3,  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 18;
		vecData.push_back(data);
	}


	if(D3DXIntersectTri(	&m_pControlVertices[99].vector3, // 34
							&m_pControlVertices[100].vector3, 
							&m_pControlVertices[101].vector3,  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 1;
		vecData.push_back(data);
	}


	if(D3DXIntersectTri(	&m_pControlVertices[102].vector3, // 35
							&m_pControlVertices[103].vector3, 
							&m_pControlVertices[104].vector3,  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 2;
		vecData.push_back(data);
	}


	if(D3DXIntersectTri(	&m_pControlVertices[105].vector3, // 36
							&m_pControlVertices[106].vector3, 
							&m_pControlVertices[107].vector3,  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 3;
		vecData.push_back(data);
	}



	///////////////////////////////////////////////////////////////////////////
	//   - 

	if(D3DXIntersectTri(	&m_pControlVertices[108].vector3, // 37
							&m_pControlVertices[109].vector3, 
							&m_pControlVertices[110].vector3,  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 9;
		vecData.push_back(data);
	}


	if(D3DXIntersectTri(	&m_pControlVertices[111].vector3,
							&m_pControlVertices[112].vector3, 
							&m_pControlVertices[113].vector3, // 38 
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 8;
		vecData.push_back(data);
	}


	if(D3DXIntersectTri(	&m_pControlVertices[114].vector3,
							&m_pControlVertices[115].vector3, 
							&m_pControlVertices[116].vector3, // 39
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 7;
		vecData.push_back(data);
	}


	if(D3DXIntersectTri(	&m_pControlVertices[117].vector3,
							&m_pControlVertices[118].vector3, 
							&m_pControlVertices[119].vector3, // 40  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 12;
		vecData.push_back(data);
	}

	if(D3DXIntersectTri(	&m_pControlVertices[120].vector3,
							&m_pControlVertices[121].vector3, 
							&m_pControlVertices[122].vector3, // 41  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 11;
		vecData.push_back(data);
	}


	if(D3DXIntersectTri(	&m_pControlVertices[123].vector3,
							&m_pControlVertices[124].vector3, 
							&m_pControlVertices[125].vector3, // 42  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 10;
		vecData.push_back(data);
	}


	if(D3DXIntersectTri(	&m_pControlVertices[126].vector3,
							&m_pControlVertices[127].vector3, 
							&m_pControlVertices[128].vector3, // 43  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 3;
		vecData.push_back(data);
	}
	

	if(D3DXIntersectTri(	&m_pControlVertices[129].vector3,
							&m_pControlVertices[130].vector3, 
							&m_pControlVertices[131].vector3, // 44  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 2;
		vecData.push_back(data);
	}
	

	if(D3DXIntersectTri(	&m_pControlVertices[132].vector3,
							&m_pControlVertices[133].vector3, 
							&m_pControlVertices[134].vector3, // 45  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 1;
		vecData.push_back(data);
	}
	

	if(D3DXIntersectTri(	&m_pControlVertices[135].vector3,
							&m_pControlVertices[136].vector3, 
							&m_pControlVertices[137].vector3, // 46  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 6;
		vecData.push_back(data);
	}
	

	if(D3DXIntersectTri(	&m_pControlVertices[138].vector3,
							&m_pControlVertices[139].vector3, 
							&m_pControlVertices[140].vector3, // 47  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 5;
		vecData.push_back(data);
	}
	

	if(D3DXIntersectTri(	&m_pControlVertices[141].vector3,
							&m_pControlVertices[142].vector3, 
							&m_pControlVertices[143].vector3, // 48  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 4;
		vecData.push_back(data);
	}

	

	///////////////////////////////////////////////////////////////////////////
	//  , -  


	if(D3DXIntersectTri(	&m_pControlVertices[144].vector3, 
							&m_pControlVertices[145].vector3, 
							&m_pControlVertices[146].vector3, // 49 
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 18;
		vecData.push_back(data);
	}
	

	if(D3DXIntersectTri(	&m_pControlVertices[147].vector3,
							&m_pControlVertices[148].vector3, 
							&m_pControlVertices[149].vector3, // 50  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 17;
		vecData.push_back(data);
	}
	

	if(D3DXIntersectTri(	&m_pControlVertices[150].vector3,
							&m_pControlVertices[151].vector3, 
							&m_pControlVertices[152].vector3, // 51  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 16;
		vecData.push_back(data);
	}
	

	if(D3DXIntersectTri(	&m_pControlVertices[153].vector3,
							&m_pControlVertices[154].vector3, 
							&m_pControlVertices[155].vector3, // 52  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 12;
		vecData.push_back(data);
	}
	

	if(D3DXIntersectTri(	&m_pControlVertices[156].vector3,
							&m_pControlVertices[157].vector3, 
							&m_pControlVertices[158].vector3, // 53  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 11;
		vecData.push_back(data);
	}
	

	if(D3DXIntersectTri(	&m_pControlVertices[159].vector3,
							&m_pControlVertices[160].vector3, 
							&m_pControlVertices[161].vector3, // 54  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 10;
		vecData.push_back(data);
	}
	

	if(D3DXIntersectTri(	&m_pControlVertices[162].vector3,
							&m_pControlVertices[163].vector3, 
							&m_pControlVertices[164].vector3, // 55  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 15;
		vecData.push_back(data);
	}
	

	if(D3DXIntersectTri(	&m_pControlVertices[165].vector3,
							&m_pControlVertices[166].vector3, 
							&m_pControlVertices[167].vector3, // 56  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 14;
		vecData.push_back(data);
	}
	

	if(D3DXIntersectTri(	&m_pControlVertices[168].vector3,
							&m_pControlVertices[169].vector3, 
							&m_pControlVertices[170].vector3, // 57  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 13;
		vecData.push_back(data);
	}
	

	if(D3DXIntersectTri(	&m_pControlVertices[171].vector3,
							&m_pControlVertices[172].vector3, 
							&m_pControlVertices[173].vector3, // 58  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 6;
		vecData.push_back(data);
	}
	

	if(D3DXIntersectTri(	&m_pControlVertices[174].vector3,
							&m_pControlVertices[175].vector3, 
							&m_pControlVertices[176].vector3, // 59  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 5;
		vecData.push_back(data);
	}
	

	if(D3DXIntersectTri(	&m_pControlVertices[177].vector3,
							&m_pControlVertices[178].vector3, 
							&m_pControlVertices[179].vector3, // 60  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 4;
		vecData.push_back(data);
	}


	///////////////////////////////////////////////////////////////////////////
	//    -  


	if(D3DXIntersectTri(	&m_pControlVertices[180].vector3,
							&m_pControlVertices[181].vector3, 
							&m_pControlVertices[182].vector3, // 61  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 18;
		vecData.push_back(data);
	}


	if(D3DXIntersectTri(	&m_pControlVertices[183].vector3,
							&m_pControlVertices[184].vector3, 
							&m_pControlVertices[185].vector3, // 62  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 17;
		vecData.push_back(data);
	}


	if(D3DXIntersectTri(	&m_pControlVertices[186].vector3,
							&m_pControlVertices[187].vector3, 
							&m_pControlVertices[188].vector3, // 63  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 16;
		vecData.push_back(data);
	}


	if(D3DXIntersectTri(	&m_pControlVertices[189].vector3,
							&m_pControlVertices[190].vector3, 
							&m_pControlVertices[191].vector3, // 64  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 3;
		vecData.push_back(data);
	}


	if(D3DXIntersectTri(	&m_pControlVertices[192].vector3, 
							&m_pControlVertices[193].vector3, 
							&m_pControlVertices[194].vector3, // 65 
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 2;
		vecData.push_back(data);
	}


	if(D3DXIntersectTri(	&m_pControlVertices[195].vector3,
							&m_pControlVertices[196].vector3, 
							&m_pControlVertices[197].vector3, // 66  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 1;
		vecData.push_back(data);
	}
	

	if(D3DXIntersectTri(	&m_pControlVertices[198].vector3,
							&m_pControlVertices[199].vector3, 
							&m_pControlVertices[200].vector3, // 67
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 15;
		vecData.push_back(data);
	}


	if(D3DXIntersectTri(	&m_pControlVertices[201].vector3,
							&m_pControlVertices[202].vector3, 
							&m_pControlVertices[203].vector3, //68  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 14;
		vecData.push_back(data);
	}
	

	if(D3DXIntersectTri(	&m_pControlVertices[204].vector3,
							&m_pControlVertices[205].vector3, 
							&m_pControlVertices[206].vector3, // 69  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 13;
		vecData.push_back(data);
	}


	if(D3DXIntersectTri(	&m_pControlVertices[207].vector3,
							&m_pControlVertices[208].vector3, 
							&m_pControlVertices[209].vector3, // 70
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 9;
		vecData.push_back(data);
	}


	if(D3DXIntersectTri(	&m_pControlVertices[210].vector3,
							&m_pControlVertices[211].vector3, 
							&m_pControlVertices[212].vector3, // 71  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 8;
		vecData.push_back(data);
	}


	if(D3DXIntersectTri(	&m_pControlVertices[213].vector3,
							&m_pControlVertices[214].vector3, 
							&m_pControlVertices[215].vector3, // 72  
				&vPickRayOrig, &vPickRayDir, 
				&fBary1, &fBary2, &fDist) == TRUE)
	{
		DATAINTERSECT data;
		data.distance   = fDist;
		data.numberrotate = 7;
		vecData.push_back(data);
	}



	///////////////////////////////////////////////////////////////////////////
	// 

	//        .
	std::sort(vecData.begin(), vecData.end(), SORT);

	//      ...
	if(vecData.size() > 0)
	{
		//      Z.
		*number_rotate = vecData[0].numberrotate;

		//     ,
		//    ,
		//  .
		if(vecData[0].numberrotate == -1)
		{
			return FALSE;
		}
		
		return TRUE;
	}
		

	return FALSE;
}


bool CCubeRube::RotateFrame(void)
{
	
	if(m_IsRotate == true)
	{
		static float count_step = 0;
		
		//       
		//  6 .
		float step = 6.0f;
		float k = 1.0f;
		//      ,
		//   .
		if(m_IsShuffle == true)
		{
			step = 2.0f;
		}
		
		//     
		int count_frame = (int)m_vecMatrixs.size();
		if(count_step < step)
		{
			switch(m_NumberFrame)
			{
				case 1:
					//       Z,
					//  -5.5    
					//  ,  
					//     666
					for(int i = 0; i < count_frame; i++)
					{
						if(m_vecMatrixs[i]->m[3][2] <= -5.5f )
						{
							
							D3DXMatrixRotationZ(&m_matRotate, D3DXToRadian(90)/step);
							D3DXMatrixMultiply(m_vecMatrixs[i], m_vecMatrixs[i], &m_matRotate);
						}
					
					}
					break;
				case 2:
					//   
					//   Z.
					for(int i = 0; i < count_frame; i++)
					{
						if(m_vecMatrixs[i]->m[3][2] <= 3.0 && m_vecMatrixs[i]->m[3][2] > -3.0)
						{
							D3DXMatrixRotationZ(&m_matRotate, D3DXToRadian(90)/step);
							D3DXMatrixMultiply(m_vecMatrixs[i], m_vecMatrixs[i], &m_matRotate);
						}
					
					}
					break;
				case 3:
					//  " "   Z.
					for(int i = 0; i < count_frame; i++)
					{
						if(m_vecMatrixs[i]->m[3][2] > 5.5f)
						{
							D3DXMatrixRotationZ(&m_matRotate, D3DXToRadian(90)/step);
							D3DXMatrixMultiply(m_vecMatrixs[i], m_vecMatrixs[i], &m_matRotate);
						}
					
					}
					break;
				case 4:
					//  X.
					for(int i = 0; i < count_frame; i++)
					{
						if(m_vecMatrixs[i]->m[3][0] <= -5.5f)
						{
							D3DXMatrixRotationX(&m_matRotate, D3DXToRadian(90)/step);
							D3DXMatrixMultiply(m_vecMatrixs[i], m_vecMatrixs[i], &m_matRotate);
						}
					
					}
					break;
				case 5:
					//  .
					for(int i = 0; i < count_frame; i++)
					{
						if(m_vecMatrixs[i]->m[3][0] <= 3.0 && m_vecMatrixs[i]->m[3][0] > -3.0)
						{
							D3DXMatrixRotationX(&m_matRotate, D3DXToRadian(90)/step);
							D3DXMatrixMultiply(m_vecMatrixs[i], m_vecMatrixs[i], &m_matRotate);
						}
					
					}
					break;
				case 6:
					//  .
					for(int i = 0; i < count_frame; i++)
					{
						if(m_vecMatrixs[i]->m[3][0] > 5.5f)
						{
							D3DXMatrixRotationX(&m_matRotate, D3DXToRadian(90)/step);
							D3DXMatrixMultiply(m_vecMatrixs[i], m_vecMatrixs[i], &m_matRotate);
						}
					
					}
					break;
				case 7:
					//  Z  .
					for(int i = 0; i < count_frame; i++)
					{
						if(m_vecMatrixs[i]->m[3][2] > 5.5f)
						{
							D3DXMatrixRotationZ(&m_matRotate, D3DXToRadian(-90)/step);
							D3DXMatrixMultiply(m_vecMatrixs[i], m_vecMatrixs[i], &m_matRotate);
						}
					
					}
					break;
				case 8:
					//  Z  .
					for(int i = 0; i < count_frame; i++)
					{
						if(m_vecMatrixs[i]->m[3][2] <= 3.0 && m_vecMatrixs[i]->m[3][2] > -3.0)
						{
							D3DXMatrixRotationZ(&m_matRotate, D3DXToRadian(-90)/step);
							D3DXMatrixMultiply(m_vecMatrixs[i], m_vecMatrixs[i], &m_matRotate);
						}
					
					}
					break;
				case 9:
					//  Z  .
					for(int i = 0; i < count_frame; i++)
					{
						if(m_vecMatrixs[i]->m[3][2] <= -5.5f)
						{
							D3DXMatrixRotationZ(&m_matRotate, D3DXToRadian(-90)/step);
							D3DXMatrixMultiply(m_vecMatrixs[i], m_vecMatrixs[i], &m_matRotate);
						}
					
					}
					break;
				case 10:
					//    .
					for(int i = 0; i < count_frame; i++)
					{
						if(m_vecMatrixs[i]->m[3][0] > 5.5f)
						{
							D3DXMatrixRotationX(&m_matRotate, D3DXToRadian(-90)/step);
							D3DXMatrixMultiply(m_vecMatrixs[i], m_vecMatrixs[i], &m_matRotate);
						}
					
					}
					break;
				case 11:
					//    .
					for(int i = 0; i < count_frame; i++)
					{
						if(m_vecMatrixs[i]->m[3][0] <= 3.0 && m_vecMatrixs[i]->m[3][0] > -3.0)
						{
							D3DXMatrixRotationX(&m_matRotate, D3DXToRadian(-90)/step);
							D3DXMatrixMultiply(m_vecMatrixs[i], m_vecMatrixs[i], &m_matRotate);
						}
					
					}
					break;
				case 12:
					//    .
					for(int i = 0; i < count_frame; i++)
					{
						if(m_vecMatrixs[i]->m[3][0] <= -5.5f)
						{
							D3DXMatrixRotationX(&m_matRotate, D3DXToRadian(-90)/step);
							D3DXMatrixMultiply(m_vecMatrixs[i], m_vecMatrixs[i], &m_matRotate);
						}
					
					}
					break;
				case 13:
					//  Y.
					for(int i = 0; i < count_frame; i++)
					{
						if(m_vecMatrixs[i]->m[3][1] <= -5.5f)
						{
							D3DXMatrixRotationY(&m_matRotate, D3DXToRadian(90)/step);
							D3DXMatrixMultiply(m_vecMatrixs[i], m_vecMatrixs[i], &m_matRotate);
						}
					
					}
					break;
				case 14:
					//  Y.
					for(int i = 0; i < count_frame; i++)
					{
						if(m_vecMatrixs[i]->m[3][1] <= 3.0 && m_vecMatrixs[i]->m[3][1] > -3.0)
						{
							D3DXMatrixRotationY(&m_matRotate, D3DXToRadian(90)/step);
							D3DXMatrixMultiply(m_vecMatrixs[i], m_vecMatrixs[i], &m_matRotate);
						}
					
					}
					break;
				case 15:
					//  Y.
					for(int i = 0; i < count_frame; i++)
					{
						if(m_vecMatrixs[i]->m[3][1] > 5.5f)
						{
							D3DXMatrixRotationY(&m_matRotate, D3DXToRadian(90)/step);
							D3DXMatrixMultiply(m_vecMatrixs[i], m_vecMatrixs[i], &m_matRotate);
						}
					
					}
					break;
				case 16:
					//  Y  .
					for(int i = 0; i < count_frame; i++)
					{
						if(m_vecMatrixs[i]->m[3][1] > 5.5f)
						{
							D3DXMatrixRotationY(&m_matRotate, D3DXToRadian(-90)/step);
							D3DXMatrixMultiply(m_vecMatrixs[i], m_vecMatrixs[i], &m_matRotate);
						}
					
					}
					break;
				case 17:
					//  Y  .
					for(int i = 0; i < count_frame; i++)
					{
						if(m_vecMatrixs[i]->m[3][1] <= 3.0 && m_vecMatrixs[i]->m[3][1] > -3.0)
						{
							D3DXMatrixRotationY(&m_matRotate, D3DXToRadian(-90)/step);
							D3DXMatrixMultiply(m_vecMatrixs[i], m_vecMatrixs[i], &m_matRotate);
						}
					
					}
					break;
				case 18:
					//  Y  .
					for(int i = 0; i < count_frame; i++)
					{
						if(m_vecMatrixs[i]->m[3][1] <= -5.5f)
						{
							D3DXMatrixRotationY(&m_matRotate, D3DXToRadian(-90)/step);
							D3DXMatrixMultiply(m_vecMatrixs[i], m_vecMatrixs[i], &m_matRotate);
						}
					
					}
					break;
					//

			
			}// switch(m_NumberFrame){

			count_step++;

		}// if(count_step != step){
		else
		{
			m_IsRotate = false;
			count_step = 0.0f;
			return CheckCubeComplect();
		}
	}//if(m_IsRotate == true)

	return false;
}

//      ,          
int CCubeRube::GetNumberBackRotate(int rotate)
{
	int back_rotate = 0;
	if(rotate == 1) back_rotate = 9;
	if(rotate == 2) back_rotate = 8;
	if(rotate == 3) back_rotate = 7;

	if(rotate == 4) back_rotate = 12;
	if(rotate == 5) back_rotate = 11;
	if(rotate == 6) back_rotate = 10;

	if(rotate == 7) back_rotate = 3;
	if(rotate == 8) back_rotate = 2;
	if(rotate == 9) back_rotate = 1;

	if(rotate == 10) back_rotate = 6;
	if(rotate == 11) back_rotate = 5;
	if(rotate == 12) back_rotate = 4;

	if(rotate == 13) back_rotate = 18;
	if(rotate == 14) back_rotate = 17;
	if(rotate == 15) back_rotate = 16;

	if(rotate == 16) back_rotate = 15;
	if(rotate == 17) back_rotate = 14;
	if(rotate == 18) back_rotate = 13;


	return back_rotate;
}

bool CCubeRube::BeginRotateFrame(bool backrotate)
{
	if(m_IsRotate == true) return false;

	//    ,      
	if(backrotate == false)
	{
		m_vecBackRotate.push_back(GetNumberBackRotate(m_NumberFrame));
	}

	m_IsRotate = true;

	return true;

}

//   .
void CCubeRube::Shuffle()
{
	//   ,  ,
	//     ,      "".
	//  m_IsRotate         ,
	// ..      ,    .
	if(m_ModeGame == false)
		if(m_IsRotate == true) return;


	static count_rotate = 0;
	if(m_IsShuffle == true)
	{
		if(count_rotate < m_CountShuffleRotate)
		{
			static int pre_rot = 0;
again:
			//      .
			m_NumberFrame = 1 + rand()%18;
			
			//     ,    ,
			//   ,      .
			if(m_NumberFrame == GetNumberBackRotate(pre_rot) || m_NumberFrame == pre_rot)
			{
				goto again;
			}

			BeginRotateFrame(false);
			pre_rot = m_NumberFrame;

			count_rotate++;
		}
		else
		{
			if(m_IsRotate == false)
			{
				m_IsShuffle = false;
				count_rotate = 0;
				
				//      ,
				//   .
				if(m_ModeGame == true)
					RestoreShuffle();
			}
		}

	}
}

//       .
void CCubeRube::DoShuffleRotation(int number_rotate)
{
	m_ModeGame = true;
	m_CountShuffleRotate = number_rotate;
	m_IsShuffle = true;
}

//   .
void CCubeRube::DoShuffleRotationEducation(void)
{
	m_ModeGame = false;
	m_CountShuffleRotate = m_CountShuffleRotateEducation;
	m_IsShuffle = true;
}


void CCubeRube::PrepareNewGame(void)
{
	if(m_IsRotate == true) return;
	m_vecBackRotate.clear();
	for(int i = 0; i < (int)m_vecMatrixs.size(); i++)
	{
		*m_vecMatrixs[i] = m_pmatFramesMemory[i];
	}
}

HRESULT CCubeRube::AddLight(LPDIRECT3DDEVICE9 pd3dDevice, float x, float y, float z, int index)
{
	HRESULT hr = S_OK;

	//Directional lights have only color and direction, not position. They emit parallel light

	D3DLIGHT9 light;
    ZeroMemory(&light, sizeof(D3DLIGHT9));
    light.Type        = D3DLIGHT_DIRECTIONAL;
    light.Diffuse.r   = 1.0f;
    light.Diffuse.g   = 1.0f;
    light.Diffuse.b   = 1.0f;
	light.Direction.x = x;
	light.Direction.y = y;
	light.Direction.z = z;
    
	pd3dDevice->SetLight(index, &light );
	pd3dDevice->LightEnable(index, TRUE );
	pd3dDevice->SetRenderState( D3DRS_LIGHTING, TRUE );

	return hr;
}

HRESULT CCubeRube::Render(LPDIRECT3DDEVICE9 pd3dDevice, D3DXMATRIX world)
{
	pd3dDevice->SetTransform( D3DTS_WORLD,  &world);

	//      ,
	//      .
	//        .
	//         
	//   ,  
	//         .
	//pd3dDevice->SetStreamSource( 0, m_pvbControl, 0, sizeof(CUSTOMVERTEX_CONTROL));
	//pd3dDevice->SetFVF( D3DFVF_CUSTOMVERTEX_CONTROL);
	//pd3dDevice->DrawPrimitive( D3DPT_TRIANGLELIST, 0, 72);



	//    :
	// 1) -- 
	// 2) --
	AddLight(pd3dDevice, -1.0f, -1.0f, 1.0f, 0);
	AddLight(pd3dDevice,  1.0f,  1.0f, 1.0f, 1);

	int num = (int)m_vecParseMesh.size();
	for(int v = 0; v < num; v++)
	{
		D3DXMATRIX matWorld;
		D3DXMatrixIdentity(&matWorld);
		D3DXMatrixMultiply(&matWorld, m_vecMatrixs[v], &world);
		pd3dDevice->SetTransform( D3DTS_WORLD, &matWorld);

		for( DWORD i = 0; i < m_vecParseMesh[v]->dwNumMaterials; i++ )
		{
			pd3dDevice->SetMaterial(&m_vecParseMesh[v]->pMaterials[i]);
			pd3dDevice->SetTexture(0, m_vecParseMesh[v]->pTextures[i]);
			m_vecParseMesh[v]->pMesh->DrawSubset(i);
		}
		
	}
	

	return E_NOTIMPL;
}

void CCubeRube::DataToRegistry(HKEY hKey)
{
	GlobalNumberToRegKey(hKey, "CountShuffleRotateEducation", m_CountShuffleRotateEducation);
}

void CCubeRube::DataFromRegistry(HKEY hKey)
{
	GlobalNumberFromRegKey(hKey, "CountShuffleRotateEducation", (DWORD*)&m_CountShuffleRotateEducation, 3);
}

//    
bool CCubeRube::CheckCubeComplect(void)
{
	float X_Frame[9];
	X_Frame[0] = m_vecMatrixs[2]->m[3][0];
	X_Frame[1] = m_vecMatrixs[3]->m[3][0];
	X_Frame[2] = m_vecMatrixs[4]->m[3][0];
	X_Frame[3] = m_vecMatrixs[11]->m[3][0];
	X_Frame[4] = m_vecMatrixs[12]->m[3][0];
	X_Frame[5] = m_vecMatrixs[13]->m[3][0];
	X_Frame[6] = m_vecMatrixs[20]->m[3][0];
	X_Frame[7] = m_vecMatrixs[21]->m[3][0];
	X_Frame[8] = m_vecMatrixs[22]->m[3][0];

	//     
	//    .
	int count_x = 0;
	for(int i = 0; i < 9; i++)
	{
		if(	X_Frame[0] > (X_Frame[i]-0.1f) &&
			X_Frame[0] < (X_Frame[i]+0.1f))
			count_x++;
	}

	float Y_Frame[9];
	Y_Frame[0] = m_vecMatrixs[2]->m[3][1];
	Y_Frame[1] = m_vecMatrixs[3]->m[3][1];
	Y_Frame[2] = m_vecMatrixs[4]->m[3][1];
	Y_Frame[3] = m_vecMatrixs[11]->m[3][1];
	Y_Frame[4] = m_vecMatrixs[12]->m[3][1];
	Y_Frame[5] = m_vecMatrixs[13]->m[3][1];
	Y_Frame[6] = m_vecMatrixs[20]->m[3][1];
	Y_Frame[7] = m_vecMatrixs[21]->m[3][1];
	Y_Frame[8] = m_vecMatrixs[22]->m[3][1];


	//     
	//    Y.
	int count_y = 0;
	for(int i = 0; i < 9; i++)
	{
		if(	Y_Frame[0] > (Y_Frame[i]-0.1f) &&
			Y_Frame[0] < (Y_Frame[i]+0.1f))
			count_y++;
	}

	//     
	//    Z.
	float Z_Frame[9];
	Z_Frame[0] = m_vecMatrixs[2]->m[3][2];
	Z_Frame[1] = m_vecMatrixs[3]->m[3][2];
	Z_Frame[2] = m_vecMatrixs[4]->m[3][2];
	Z_Frame[3] = m_vecMatrixs[11]->m[3][2];
	Z_Frame[4] = m_vecMatrixs[12]->m[3][2];
	Z_Frame[5] = m_vecMatrixs[13]->m[3][2];
	Z_Frame[6] = m_vecMatrixs[20]->m[3][2];
	Z_Frame[7] = m_vecMatrixs[21]->m[3][2];
	Z_Frame[8] = m_vecMatrixs[22]->m[3][2];

	int count_z = 0;
	for(int i = 0; i < 9; i++)
	{
		if(	Z_Frame[0] > (Z_Frame[i]-0.1f) &&
			Z_Frame[0] < (Z_Frame[i]+0.1f))
			count_z++;
	}

	/////////////////////////////////////////////////////////////////////////////////////
	X_Frame[0] = m_vecMatrixs[4]->m[3][0];
	X_Frame[1] = m_vecMatrixs[5]->m[3][0];
	X_Frame[2] = m_vecMatrixs[6]->m[3][0];
	X_Frame[3] = m_vecMatrixs[13]->m[3][0];
	X_Frame[4] = m_vecMatrixs[14]->m[3][0];
	X_Frame[5] = m_vecMatrixs[15]->m[3][0];
	X_Frame[6] = m_vecMatrixs[22]->m[3][0];
	X_Frame[7] = m_vecMatrixs[23]->m[3][0];
	X_Frame[8] = m_vecMatrixs[24]->m[3][0];

	int count_x1 = 0;
	for(int i = 0; i < 9; i++)
	{
		if(	X_Frame[0] > (X_Frame[i]-0.1f) &&
			X_Frame[0] < (X_Frame[i]+0.1f))
			count_x1++;
	}

	Y_Frame[0] = m_vecMatrixs[4]->m[3][1];
	Y_Frame[1] = m_vecMatrixs[5]->m[3][1];
	Y_Frame[2] = m_vecMatrixs[6]->m[3][1];
	Y_Frame[3] = m_vecMatrixs[13]->m[3][1];
	Y_Frame[4] = m_vecMatrixs[14]->m[3][1];
	Y_Frame[5] = m_vecMatrixs[15]->m[3][1];
	Y_Frame[6] = m_vecMatrixs[22]->m[3][1];
	Y_Frame[7] = m_vecMatrixs[23]->m[3][1];
	Y_Frame[8] = m_vecMatrixs[24]->m[3][1];

	int count_y1 = 0;
	for(int i = 0; i < 9; i++)
	{
		if(	Y_Frame[0] > (Y_Frame[i]-0.1f) &&
			Y_Frame[0] < (Y_Frame[i]+0.1f))
			count_y1++;
	}

	Z_Frame[0] = m_vecMatrixs[4]->m[3][2];
	Z_Frame[1] = m_vecMatrixs[5]->m[3][2];
	Z_Frame[2] = m_vecMatrixs[6]->m[3][2];
	Z_Frame[3] = m_vecMatrixs[13]->m[3][2];
	Z_Frame[4] = m_vecMatrixs[14]->m[3][2];
	Z_Frame[5] = m_vecMatrixs[15]->m[3][2];
	Z_Frame[6] = m_vecMatrixs[22]->m[3][2];
	Z_Frame[7] = m_vecMatrixs[23]->m[3][2];
	Z_Frame[8] = m_vecMatrixs[24]->m[3][2];

	int count_z1 = 0;
	for(int i = 0; i < 9; i++)
	{
		if(	Z_Frame[0] > (Z_Frame[i]-0.1f) &&
			Z_Frame[0] < (Z_Frame[i]+0.1f))
			count_z1++;
	}

////////////////////////////////////////////////////////////////////////////////////////////////
	X_Frame[0] = m_vecMatrixs[0]->m[3][0];
	X_Frame[1] = m_vecMatrixs[1]->m[3][0];
	X_Frame[2] = m_vecMatrixs[2]->m[3][0];
	X_Frame[3] = m_vecMatrixs[3]->m[3][0];
	X_Frame[4] = m_vecMatrixs[4]->m[3][0];
	X_Frame[5] = m_vecMatrixs[5]->m[3][0];
	X_Frame[6] = m_vecMatrixs[6]->m[3][0];
	X_Frame[7] = m_vecMatrixs[7]->m[3][0];
	X_Frame[8] = m_vecMatrixs[8]->m[3][0];

	int count_x2 = 0;
	for(int i = 0; i < 9; i++)
	{
		if(	X_Frame[0] > (X_Frame[i]-0.1f) &&
			X_Frame[0] < (X_Frame[i]+0.1f))
			count_x2++;
	}

	Y_Frame[0] = m_vecMatrixs[0]->m[3][1];
	Y_Frame[1] = m_vecMatrixs[1]->m[3][1];
	Y_Frame[2] = m_vecMatrixs[2]->m[3][1];
	Y_Frame[3] = m_vecMatrixs[3]->m[3][1];
	Y_Frame[4] = m_vecMatrixs[4]->m[3][1];
	Y_Frame[5] = m_vecMatrixs[5]->m[3][1];
	Y_Frame[6] = m_vecMatrixs[6]->m[3][1];
	Y_Frame[7] = m_vecMatrixs[7]->m[3][1];
	Y_Frame[8] = m_vecMatrixs[8]->m[3][1];

	int count_y2 = 0;
	for(int i = 0; i < 9; i++)
	{
		if(	Y_Frame[0] > (Y_Frame[i]-0.1f) &&
			Y_Frame[0] < (Y_Frame[i]+0.1f))
			count_y2++;
	}

	Z_Frame[0] = m_vecMatrixs[0]->m[3][2];
	Z_Frame[1] = m_vecMatrixs[1]->m[3][2];
	Z_Frame[2] = m_vecMatrixs[2]->m[3][2];
	Z_Frame[3] = m_vecMatrixs[3]->m[3][2];
	Z_Frame[4] = m_vecMatrixs[4]->m[3][2];
	Z_Frame[5] = m_vecMatrixs[5]->m[3][2];
	Z_Frame[6] = m_vecMatrixs[6]->m[3][2];
	Z_Frame[7] = m_vecMatrixs[7]->m[3][2];
	Z_Frame[8] = m_vecMatrixs[8]->m[3][2];

	int count_z2 = 0;
	for(int i = 0; i < 9; i++)
	{
		if(	Z_Frame[0] > (Z_Frame[i]-0.1f) &&
			Z_Frame[0] < (Z_Frame[i]+0.1f))
			count_z2++;
	}

	//    ,
	//    .
	if( (count_x  == 9 || count_y  == 9 || count_z  == 9) &&
		(count_x1 == 9 || count_y1 == 9 || count_z1 == 9) &&
		(count_x2 == 9 || count_y2 == 9 || count_z2 == 9)   )
	{
		//AfxMessageBox("!!!");
		return true;
			
	}

	return false;
}



void CCubeRube::RestoreShuffle(void)
{
	//       
	//      ,
	//      .
	PrepareNewGame();


	for(int i = 0; i < 27; i++)
	{
		m_NumberFrame = 1 + rand()%18;
		//     
		int count_frame = (int)m_vecMatrixs.size();
		switch(m_NumberFrame)
		{
			case 1:
				for(int i = 0; i < count_frame; i++)
				{
					if(m_vecMatrixs[i]->m[3][2] <= -5.5f )
					{
						D3DXMatrixRotationZ(&m_matRotate, D3DXToRadian(90));
						D3DXMatrixMultiply(m_vecMatrixs[i], m_vecMatrixs[i], &m_matRotate);
					}
				
				}
				break;
			case 2:
				for(int i = 0; i < count_frame; i++)
				{
					if(m_vecMatrixs[i]->m[3][2] <= 3.0 && m_vecMatrixs[i]->m[3][2] > -3.0)
					{
						D3DXMatrixRotationZ(&m_matRotate, D3DXToRadian(90));
						D3DXMatrixMultiply(m_vecMatrixs[i], m_vecMatrixs[i], &m_matRotate);
					}
				
				}
				break;
			case 3:
				for(int i = 0; i < count_frame; i++)
				{
					if(m_vecMatrixs[i]->m[3][2] > 5.5f )
					{
						D3DXMatrixRotationZ(&m_matRotate, D3DXToRadian(90));
						D3DXMatrixMultiply(m_vecMatrixs[i], m_vecMatrixs[i], &m_matRotate);
					}
				
				}
				break;
			case 4:
				for(int i = 0; i < count_frame; i++)
				{
					if(m_vecMatrixs[i]->m[3][0] <= -5.5f )
					{
						D3DXMatrixRotationX(&m_matRotate, D3DXToRadian(90));
						D3DXMatrixMultiply(m_vecMatrixs[i], m_vecMatrixs[i], &m_matRotate);
					}
				
				}
				break;
			case 5:
				for(int i = 0; i < count_frame; i++)
				{
					if(m_vecMatrixs[i]->m[3][0] <= 3.0 && m_vecMatrixs[i]->m[3][0] > -3.0)
					{
						D3DXMatrixRotationX(&m_matRotate, D3DXToRadian(90));
						D3DXMatrixMultiply(m_vecMatrixs[i], m_vecMatrixs[i], &m_matRotate);
					}
				
				}
				break;
			case 6:
				for(int i = 0; i < count_frame; i++)
				{
					if(m_vecMatrixs[i]->m[3][0] > 5.5f )
					{
						D3DXMatrixRotationX(&m_matRotate, D3DXToRadian(90));
						D3DXMatrixMultiply(m_vecMatrixs[i], m_vecMatrixs[i], &m_matRotate);
					}
				
				}
				break;
			case 7:
				for(int i = 0; i < count_frame; i++)
				{
					if(m_vecMatrixs[i]->m[3][2] > 5.5f)
					{
						D3DXMatrixRotationZ(&m_matRotate, D3DXToRadian(-90));
						D3DXMatrixMultiply(m_vecMatrixs[i], m_vecMatrixs[i], &m_matRotate);
					}
				
				}
				break;
			case 8:
				for(int i = 0; i < count_frame; i++)
				{
					if(m_vecMatrixs[i]->m[3][2] <= 3.0 && m_vecMatrixs[i]->m[3][2] > -3.0)
					{
						D3DXMatrixRotationZ(&m_matRotate, D3DXToRadian(-90));
						D3DXMatrixMultiply(m_vecMatrixs[i], m_vecMatrixs[i], &m_matRotate);
					}
				
				}
				break;
			case 9:
				for(int i = 0; i < count_frame; i++)
				{
					if(m_vecMatrixs[i]->m[3][2] <= -5.5f )
					{
						D3DXMatrixRotationZ(&m_matRotate, D3DXToRadian(-90));
						D3DXMatrixMultiply(m_vecMatrixs[i], m_vecMatrixs[i], &m_matRotate);
					}
				
				}
				break;
			case 10:
				for(int i = 0; i < count_frame; i++)
				{
					if(m_vecMatrixs[i]->m[3][0] > 5.5f )
					{
						D3DXMatrixRotationX(&m_matRotate, D3DXToRadian(-90));
						D3DXMatrixMultiply(m_vecMatrixs[i], m_vecMatrixs[i], &m_matRotate);
					}
				
				}
				break;
			case 11:
				for(int i = 0; i < count_frame; i++)
				{
					if(m_vecMatrixs[i]->m[3][0] <= 3.0 && m_vecMatrixs[i]->m[3][0] > -3.0)
					{
						D3DXMatrixRotationX(&m_matRotate, D3DXToRadian(-90));
						D3DXMatrixMultiply(m_vecMatrixs[i], m_vecMatrixs[i], &m_matRotate);
					}
				
				}
				break;
			case 12:
				for(int i = 0; i < count_frame; i++)
				{
					if(m_vecMatrixs[i]->m[3][0] <= -5.5f )
					{
						D3DXMatrixRotationX(&m_matRotate, D3DXToRadian(-90));
						D3DXMatrixMultiply(m_vecMatrixs[i], m_vecMatrixs[i], &m_matRotate);
					}
				
				}
				break;
			case 13:
				for(int i = 0; i < count_frame; i++)
				{
					if(m_vecMatrixs[i]->m[3][1] <= -5.5f)
					{
						D3DXMatrixRotationY(&m_matRotate, D3DXToRadian(90));
						D3DXMatrixMultiply(m_vecMatrixs[i], m_vecMatrixs[i], &m_matRotate);
					}
				
				}
				break;
			case 14:
				for(int i = 0; i < count_frame; i++)
				{
					if(m_vecMatrixs[i]->m[3][1] <= 3.0 && m_vecMatrixs[i]->m[3][1] > -3.0)
					{
						D3DXMatrixRotationY(&m_matRotate, D3DXToRadian(90));
						D3DXMatrixMultiply(m_vecMatrixs[i], m_vecMatrixs[i], &m_matRotate);
					}
				
				}
				break;
			case 15:
				for(int i = 0; i < count_frame; i++)
				{
					if(m_vecMatrixs[i]->m[3][1] > 5.5f )
					{
						D3DXMatrixRotationY(&m_matRotate, D3DXToRadian(90));
						D3DXMatrixMultiply(m_vecMatrixs[i], m_vecMatrixs[i], &m_matRotate);
					}
				
				}
				break;
			case 16:
				for(int i = 0; i < count_frame; i++)
				{
					if(m_vecMatrixs[i]->m[3][1] > 5.5f )
					{
						D3DXMatrixRotationY(&m_matRotate, D3DXToRadian(-90));
						D3DXMatrixMultiply(m_vecMatrixs[i], m_vecMatrixs[i], &m_matRotate);
					}
				
				}
				break;
			case 17:
				for(int i = 0; i < count_frame; i++)
				{
					if(m_vecMatrixs[i]->m[3][1] <= 3.0 && m_vecMatrixs[i]->m[3][1] > -3.0)
					{
						D3DXMatrixRotationY(&m_matRotate, D3DXToRadian(-90));
						D3DXMatrixMultiply(m_vecMatrixs[i], m_vecMatrixs[i], &m_matRotate);
					}
				
				}
				break;
			case 18:
				for(int i = 0; i < count_frame; i++)
				{
					if(m_vecMatrixs[i]->m[3][1] <= -5.5f )
					{
						D3DXMatrixRotationY(&m_matRotate, D3DXToRadian(-90));
						D3DXMatrixMultiply(m_vecMatrixs[i], m_vecMatrixs[i], &m_matRotate);
					}
				
				}
				break;
				//

		
		} // switch(m_NumberFrame)
	} // for(int i = 0; i < 2; i++)
}

void CCubeRube::BackRotate(void)
{
	//       
	//    ,    

	if(m_IsRotate == false)
	{
		if(m_vecBackRotate.size() > 0)
		{
			m_NumberFrame = m_vecBackRotate[m_vecBackRotate.size()-1];
			m_vecBackRotate.erase(m_vecBackRotate.end()-1);
			BeginRotateFrame(true);
		}
	}
}

//       
void CCubeRube::PerformRotateFrame(CWnd* pParent)
{
	CChildView* pView = (CChildView*)pParent;

	//      ,
	//     ,   
	//  
	if(m_IsRotate == false)
	{
		CRect rc;
		pView->GetClientRect(&rc);
		if(CalculateIntersect(rc.Width(), rc.Height(), 
			pView->m_World, pView->m_matView, pView->m_matProj, &m_NumberFrame) == TRUE)
		{
			
			BeginRotateFrame(false);
		}
	}
}

//         
void CCubeRube::StateCubeForEducation(int state)
{	
	//      
	PrepareNewGame();

	int count_frame = (int)m_vecMatrixs.size();
	switch(state)
	{
	case 0:
		DoShuffleRotationEducation();
		break;
	case 1:
		//   :   
		for(int i = 0; i < count_frame; i++)
		{
			if(m_vecMatrixs[i]->m[3][0] <= 3.0 && m_vecMatrixs[i]->m[3][0] > -3.0)
			{
				D3DXMatrixRotationX(&m_matRotate, D3DXToRadian(90));
				D3DXMatrixMultiply(m_vecMatrixs[i], m_vecMatrixs[i], &m_matRotate);
			}
			if(m_vecMatrixs[i]->m[3][1] <= 3.0 && m_vecMatrixs[i]->m[3][1] > -3.0)
			{
				D3DXMatrixRotationY(&m_matRotate, D3DXToRadian(90));
				D3DXMatrixMultiply(m_vecMatrixs[i], m_vecMatrixs[i], &m_matRotate);
			}
			if(m_vecMatrixs[i]->m[3][0] <= 3.0 && m_vecMatrixs[i]->m[3][0] > -3.0)
			{
				D3DXMatrixRotationX(&m_matRotate, D3DXToRadian(-90));
				D3DXMatrixMultiply(m_vecMatrixs[i], m_vecMatrixs[i], &m_matRotate);
			}
			if(m_vecMatrixs[i]->m[3][1] <= 3.0 && m_vecMatrixs[i]->m[3][1] > -3.0)
			{
				D3DXMatrixRotationY(&m_matRotate, D3DXToRadian(-90));
				D3DXMatrixMultiply(m_vecMatrixs[i], m_vecMatrixs[i], &m_matRotate);
			}
		}
		break;
	case 2:
		//  :      .
		for(int i = 0; i < count_frame; i++)
		{
			if(m_vecMatrixs[i]->m[3][0] <= -5.5f )
			{
				D3DXMatrixRotationX(&m_matRotate, D3DXToRadian(180));
				D3DXMatrixMultiply(m_vecMatrixs[i], m_vecMatrixs[i], &m_matRotate);
			}

			if(m_vecMatrixs[i]->m[3][0] > 5.5f )
			{
				D3DXMatrixRotationX(&m_matRotate, D3DXToRadian(180));
				D3DXMatrixMultiply(m_vecMatrixs[i], m_vecMatrixs[i], &m_matRotate);
			}

			if(m_vecMatrixs[i]->m[3][2] <= 3.0 && m_vecMatrixs[i]->m[3][2] > -3.0)
			{
				D3DXMatrixRotationZ(&m_matRotate, D3DXToRadian(180));
				D3DXMatrixMultiply(m_vecMatrixs[i], m_vecMatrixs[i], &m_matRotate);
			}

			if(m_vecMatrixs[i]->m[3][1] <= 3.0 && m_vecMatrixs[i]->m[3][1] > -3.0)
			{
				D3DXMatrixRotationY(&m_matRotate, D3DXToRadian(180));
				D3DXMatrixMultiply(m_vecMatrixs[i], m_vecMatrixs[i], &m_matRotate);
			}
		
		}
		break;
	case 3:
		break;
	}
}
