////////////////////////////////////////////////////////////////////////////////////
//
//			http://www.interestprograms.ru - ,     
//
/////////////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include ".\dimouse.h"
#include "ChildView.h"




CDIMouse::CDIMouse(void)
: m_pDI(NULL)      
, m_pMouse(NULL)
, m_AngleX(0)
, m_AngleY(0)
, m_ScaleZ(-50.0f)
{
	
}

CDIMouse::~CDIMouse(void)
{
	SAFE_RELEASE(m_pMouse);
	SAFE_RELEASE(m_pDI);
}


HRESULT CDIMouse::InitDIMouse(CWnd* pParent)
{
	HRESULT hr;

	//   DirectInput     ,
	// , ,   .
	hr = DirectInput8Create(AfxGetApp()->m_hInstance, DIRECTINPUT_VERSION,
								IID_IDirectInput8, (VOID**)&m_pDI, NULL);
	if(hr != S_OK) return hr;
	 
	//      .
	hr = m_pDI->CreateDevice(GUID_SysMouse, &m_pMouse, NULL);
	if(hr != S_OK) return hr;


	//      .
	//   c_dfDIMouse,  
	//         .
	hr = m_pMouse->SetDataFormat(&c_dfDIMouse);
	if(hr != S_OK) return hr;

	//    .
	//     ,
	//   DirectInput,
	//      
	//       .
	hr = m_pMouse->SetCooperativeLevel(pParent->GetParent()->m_hWnd,
               DISCL_NONEXCLUSIVE | DISCL_FOREGROUND);

	return hr;
}

//      .
void CDIMouse::ProcessingMouseEvent(CWnd* pParent)
{
	if(m_pMouse == NULL) return;
	
	HRESULT       hr = S_OK;
	DIMOUSESTATE dims;

	//     
	ZeroMemory(&dims, sizeof(dims));

	//     .
	hr = m_pMouse->GetDeviceState( sizeof(DIMOUSESTATE), &dims);
	if(hr != S_OK) 
	{
		//   ,
		//     .
		hr = m_pMouse->Acquire();
		while(hr == DIERR_INPUTLOST) 
			hr = m_pMouse->Acquire();

	}

	//      
	//      .
	int btindex = 0;

	//     .
	static bool down = false; //        
	if((dims.rgbButtons[0] & 0x80) == 0x80)
	{
			
		if(down == false)
		{
			btindex = 1;
			((CChildView*)pParent)->FromDIMouse(btindex);	
			down = true;
		}
	}
	else
		down = false;
	

	//     .
	if((dims.rgbButtons[1] & 0x80) == 0x80)
	{
		//       
		//    .
		//     X  180 ,
		//     Y    
		// .
		//     
		//        Y.
		//       k = -1;
		static float k = 1.0;
		if(cos(m_AngleX) < 0)
		{
			k = -1;
		}
		else
		{
			k = 1;
		}

		m_AngleY -= k*(float)dims.lX/100;
		m_AngleX -= (float)dims.lY/100;
		btindex = 2;
		((CChildView*)pParent)->FromDIMouse(btindex);
		
	}

	//     () .
	if((dims.rgbButtons[2] & 0x80) == 0x80)
	{
		btindex = 3;
		((CChildView*)pParent)->FromDIMouse(btindex);
		
	}
	
	//    .
	//  .
	if((float)dims.lZ != 0)
	{
		//   .
		if(m_ScaleZ < 65 && (float)dims.lZ/100 > 0)
		{
			m_ScaleZ += 3.2f;
		}
		if(m_ScaleZ > -65 && (float)dims.lZ/100 < 0)
		{
			m_ScaleZ -= 3.2f;
		}
	}

}
