////////////////////////////////////////////////////////////////////////////////////
//
//			http://www.interestprograms.ru - ,     
//
/////////////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "CubeRubika3.h"
#include ".\showdataplayers.h"

CShowDataPlayers::CShowDataPlayers(void)
: m_p3DFont(NULL)
, m_Color(D3DCOLOR_XRGB(255, 255,255))
, m_StartTime(false)
, m_ShowNameStopWatch(TRUE)
, m_ShowListRecordHolders(TRUE)
, m_ModeGame(false)
{
	
}

CShowDataPlayers::~CShowDataPlayers(void)
{
	SAFE_RELEASE(m_p3DFont);
}

HRESULT CShowDataPlayers::Init3DFont(LPDIRECT3DDEVICE9 pd3dDevice)
{
/*	//       .
	m_RecordHolders[0].SetPlayerName("");
	m_RecordHolders[1].SetPlayerName("");
	m_RecordHolders[2].SetPlayerName("");
	m_RecordHolders[3].SetPlayerName("");
	m_RecordHolders[4].SetPlayerName("");
	m_RecordHolders[5].SetPlayerName(""); //("");
	m_RecordHolders[6].SetPlayerName("");
	m_RecordHolders[7].SetPlayerName(""); //("");
	m_RecordHolders[8].SetPlayerName("");
	m_RecordHolders[9].SetPlayerName("");

	m_RecordHolders[0].sec = 300;
	m_RecordHolders[1].sec = 1200;
	m_RecordHolders[2].sec = 800;
	m_RecordHolders[3].sec = 1400;
	m_RecordHolders[4].sec = 500;
	m_RecordHolders[5].sec = 3000;
	m_RecordHolders[6].sec = 200; 
	m_RecordHolders[7].sec = 4760;
	m_RecordHolders[8].sec = 1800;
	m_RecordHolders[9].sec = 2560;
		*/


	return D3DXCreateFont(pd3dDevice, -16, 0, 600, 1, FALSE, DEFAULT_CHARSET, 
                              OUT_DEFAULT_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH | FF_DONTCARE, 
							"Arial", &m_p3DFont);
}

HRESULT CShowDataPlayers::Render(LPDIRECT3DDEVICE9 pd3dDevice, int x, int y)
{
	if(m_p3DFont == NULL) return D3DERR_INVALIDCALL;

	HRESULT hr = S_OK;
	int margin = 10;
	
	///////////////////////////////////////////////////////////////////////////
	//     .

	if(m_ShowNameStopWatch == TRUE)
	{
		CRect rc_font;
		//    ,      12  .
		// DrawText   DT_CALCRECT   ,    . 
		m_p3DFont->DrawText(NULL, " - ", -1, &rc_font, DT_CALCRECT, 0);
		
		//    " - ...",
		//  ,     rc_font.
		RECT rc;
		SetRect(&rc, x - rc_font.Width() - margin, margin, x - margin, rc_font.Height() + margin);
		m_p3DFont->DrawText(NULL, " - " + CString(m_Player.GetPlayerName()), -1, &rc, DT_RIGHT, m_Color);
		
		rc.top += rc_font.Height();
		rc.bottom += rc.top + rc_font.Height();

		static DWORD sec_correction = 0;
		//      .
		if(m_StartTime == false)
			sec_correction = GetTickCount()/1000; //   
		else
			m_Player.sec = GetTickCount()/1000 - sec_correction; //     

		//  .
		m_p3DFont->DrawText(NULL, "  - " + m_Player.GetTime(), -1, &rc, DT_RIGHT, m_Color);
	}

 
	///////////////////////////////////////////////////////////////////////////
	//   

	if(m_ShowListRecordHolders == TRUE)
	{
		
		CRect rc_font;
		//    ,      14     .
		// DrawText   DT_CALCRECT   ,    .
		m_p3DFont->DrawText(NULL, "00:00:00", -1, &rc_font, DT_CALCRECT, 0);

		RECT rc;
		int count = 0;
		//     
		for(int i = (NUMBERRECORDHOLDERS-1); i >= 0; i--)
		{
			if(m_RecordHolders[i].sec > 0)
			{
				
				SetRect(&rc, x - rc_font.Width() - margin, y - rc_font.Height()*(count+1) - margin, x - margin, y - rc_font.Height()*count);
				m_p3DFont->DrawText(NULL, m_RecordHolders[i].GetPlayerName(), -1, &rc, DT_LEFT, m_Color);
				m_p3DFont->DrawText(NULL, m_RecordHolders[i].GetTime(), -1, &rc, DT_RIGHT, m_Color);
				count++;
			}
		}

		//   .
		SetRect(&rc, x - rc_font.Width() - margin, y - rc_font.Height()*(count+2) - margin, x - margin, y - rc_font.Height()*(count+1));
		m_p3DFont->DrawText(NULL, " ", -1, &rc, DT_RIGHT, m_Color);

		SetRect(&rc, x - rc_font.Width() - margin, y - rc_font.Height()*(count+1) - margin, x - margin, y - rc_font.Height()*count);
		m_p3DFont->DrawText(NULL, "", -1, &rc, DT_LEFT, m_Color);
		m_p3DFont->DrawText(NULL, " ", -1, &rc, DT_RIGHT, m_Color);
	}
	
	return hr;
}

void CShowDataPlayers::SetColorFont(void)
{
	CColorDialog colordlg;
	if(colordlg.DoModal() == IDOK)
	{
		COLORREF color = colordlg.GetColor();
		//  RGB  D3DCOLOR.
		m_Color = D3DCOLOR_XRGB(GetRValue(color), GetGValue(color), GetBValue(color));
	}
}


//   ,    3D-,
//     (lost) 3D-, 
//   (reset) 3D-.
HRESULT CShowDataPlayers::Invalidate(void)
{
	if(m_p3DFont == NULL) return D3DERR_INVALIDCALL;


	return m_p3DFont->OnLostDevice();
}

//         
//  3D-.
//   (reset) 3D-,    
//   3D-.
HRESULT CShowDataPlayers::Restore(void)
{
	if(m_p3DFont == NULL) return D3DERR_INVALIDCALL;
	
	return m_p3DFont->OnResetDevice();
}


//        .
void CShowDataPlayers::DataToRegistry(HKEY hKey)
{
	GlobalStringToRegKey(hKey, "PlayerName", m_Player.GetPlayerName().GetBuffer());
	GlobalNumberToRegKey(hKey, "ColorFont", (DWORD)m_Color);
	GlobalNumberToRegKey(hKey, "ShowNameStopWatch", (DWORD)m_ShowNameStopWatch);
	GlobalNumberToRegKey(hKey, "ShowListRecordHolders", (DWORD)m_ShowListRecordHolders);
	GlobalBinaryToRegKey(hKey, "RecordHolders", (BYTE*)m_RecordHolders, NUMBERRECORDHOLDERS *  sizeof(DATAPLAYER)); 
}

//    .
void CShowDataPlayers::DataFromRegistry(HKEY hKey)
{
	try
	{
		TCHAR playername[12] = {0};
		GlobalStringFromRegKey(hKey, "PlayerName", playername, 12, "");
		m_Player.SetPlayerName(CString(playername));

		GlobalNumberFromRegKey(hKey, "ColorFont", (DWORD*)&m_Color, D3DCOLOR_XRGB(255,255,255));
		GlobalNumberFromRegKey(hKey, "ShowNameStopWatch", (DWORD*)&m_ShowNameStopWatch, TRUE);
		GlobalNumberFromRegKey(hKey, "ShowListRecordHolders", (DWORD*)&m_ShowListRecordHolders, TRUE);

		DATAPLAYER RecordHolder[10];
		GlobalBinaryFromRegKey(hKey, "RecordHolders", (BYTE*)m_RecordHolders, NUMBERRECORDHOLDERS *  sizeof(DATAPLAYER), (BYTE*)RecordHolder); 
	}
	catch(...)
	{
		AfxMessageBox("     !");
	}
}


//    
//     .
//    .
bool SORT5(DATAPLAYER d1, DATAPLAYER d2)
{
	if(d1.sec != 0 && d2.sec != 0)
		return d1.sec < d2.sec;
	else
		return d1.sec > d2.sec;
}



void CShowDataPlayers::SortRecordHolders(DATAPLAYER newrecordholder)
{
	//      
	//     .
	std::vector<DATAPLAYER> temp;
	for(int i = 0; i < NUMBERRECORDHOLDERS; i++)
	{
		temp.push_back(m_RecordHolders[i]);
	}

	//     .
	for(int i = 0; i < NUMBERRECORDHOLDERS; i++)
	{
		//         ,
		//         ,
		// ..          .
		if(temp[i].GetPlayerName() == newrecordholder.GetPlayerName())
		{
			//     ,   
			//       . C3DFont::Render()
			if(temp[i].sec > 0)
			{
				//       
				//      ,
				//         .
				if(temp[i].sec > newrecordholder.sec)
				{
					temp[i].sec = 0;
				}
				else
				{
					newrecordholder.sec = 0;
				}
			}
			
		}// if(temp[i].GetPlayerName()
	}


	//        .
	temp.push_back(newrecordholder);

	//      .
	sort(temp.begin(), temp.end(), SORT5);
	
	//        .
	for(int i = 0; i < NUMBERRECORDHOLDERS; i++)
	{
		m_RecordHolders[i] = temp[i];
	}
}

//       
//    .
void CShowDataPlayers::WriteRecordHolder(void)
{
	//    (  )
	if(m_ModeGame == true)
	{
		//  .
		StopGame();

		//    
		//     .
		SortRecordHolders(m_Player);
	}
}

void CShowDataPlayers::DeleteListRecordHolders(void)
{
	//   .
	for(int i = 0; i < NUMBERRECORDHOLDERS; i++)
	{
		m_RecordHolders[i].sec = 0;
	}
}
