////////////////////////////////////////////////////////////////////////////////////
//
//			http://www.interestprograms.ru - ,     
//
/////////////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "global.h"


HRESULT GlobalStringFromRegKey(HKEY hKey, TCHAR* strRegName, TCHAR* strData, 
													DWORD lenData, TCHAR* strDefault)
{
    DWORD Type;
    DWORD sizeData = lenData * sizeof(TCHAR);

    if(RegQueryValueEx(hKey, strRegName, 0, &Type, (BYTE*)strData, &sizeData) != ERROR_SUCCESS)
    {
		//   -   
		//  ,    .
		_tcsncpy(strData, strDefault, lenData);
		strData[lenData-1] = 0;
    }

    return S_OK;
}


HRESULT GlobalStringToRegKey(HKEY hKey, TCHAR* strRegName, TCHAR* strData)
{
    if(strData == NULL)
        return E_INVALIDARG;
        
	//   
    DWORD sizeData = ((DWORD)_tcslen(strData)+1) * sizeof(TCHAR);

    return RegSetValueEx(hKey, strRegName, 0, REG_SZ, (BYTE*)strData, sizeData);
}



HRESULT GlobalNumberFromRegKey(HKEY hKey, TCHAR* strRegName, DWORD* dwData, DWORD dwDefault)
{
    DWORD Type;
    DWORD sizeData = sizeof(DWORD);

    if(RegQueryValueEx(hKey, strRegName, 0, &Type, (BYTE*)dwData, &sizeData) != ERROR_SUCCESS)
    {
		*dwData = dwDefault;
    }

    return S_OK;
}


HRESULT GlobalNumberToRegKey(HKEY hKey, TCHAR* strRegName, DWORD dwData)
{
    return RegSetValueEx(hKey, strRegName, 0, REG_DWORD, (BYTE*)&dwData,  sizeof(DWORD));
}


HRESULT GlobalBinaryFromRegKey(HKEY hKey, TCHAR* strRegName, BYTE* pData, DWORD sizeData, BYTE* pDefault)
{
    DWORD Type;
    if(RegQueryValueEx(hKey, strRegName, 0, &Type, pData, &sizeData) != ERROR_SUCCESS)
    {
		memcpy(pData, pDefault, sizeData);
    }

    return S_OK;
}

HRESULT GlobalBinaryToRegKey(HKEY hKey, TCHAR* strRegName, BYTE* pData, DWORD sizeData)
{
    return RegSetValueEx(hKey, strRegName, 0, REG_BINARY, (BYTE*)pData,  sizeData);
}

